/*
 * Academic License - for use in teaching, academic research, and meeting
 * course requirements at degree granting institutions only.  Not for
 * government, commercial, or other organizational use.
 * File: birds_eye_view_emxAPI.c
 *
 * MATLAB Coder version            : 4.3
 * C/C++ source code generated on  : 11-Jan-2020 11:37:33
 */

/* Include Files */
#include "birds_eye_view_emxAPI.h"
#include "birds_eye_view.h"
#include "birds_eye_view_emxutil.h"
#include "rt_nonfinite.h"
#include <stdlib.h>

/* Function Definitions */

/*
 * Arguments    : int numDimensions
 *                const int *size
 * Return Type  : emxArray_real_T *
 */
emxArray_real_T *emxCreateND_real_T(int numDimensions, const int *size)
{
    emxArray_real_T *emx;
    int numEl;
    int i;
    emxInit_real_T(&emx, numDimensions);
    numEl = 1;
    for (i = 0; i < numDimensions; i++) {
        numEl *= size[i];
        emx->size[i] = size[i];
    }

    emx->data = (double *)calloc((unsigned int)numEl, sizeof(double));
    emx->numDimensions = numDimensions;
    emx->allocatedSize = numEl;
    return emx;
}

/*
 * Arguments    : double *data
 *                int numDimensions
 *                const int *size
 * Return Type  : emxArray_real_T *
 */
emxArray_real_T *emxCreateWrapperND_real_T(double *data, int numDimensions,
                                           const int *size)
{
    emxArray_real_T *emx;
    int numEl;
    int i;
    emxInit_real_T(&emx, numDimensions);
    numEl = 1;
    for (i = 0; i < numDimensions; i++) {
        numEl *= size[i];
        emx->size[i] = size[i];
    }

    emx->data = data;
    emx->numDimensions = numDimensions;
    emx->allocatedSize = numEl;
    emx->canFreeData = false;
    return emx;
}

/*
 * Arguments    : double *data
 *                int rows
 *                int cols
 * Return Type  : emxArray_real_T *
 */
emxArray_real_T *emxCreateWrapper_real_T(double *data, int rows, int cols)
{
    emxArray_real_T *emx;
    emxInit_real_T(&emx, 2);
    emx->size[0] = rows;
    emx->size[1] = cols;
    emx->data = data;
    emx->numDimensions = 2;
    emx->allocatedSize = rows * cols;
    emx->canFreeData = false;
    return emx;
}

/*
 * Arguments    : int rows
 *                int cols
 * Return Type  : emxArray_real_T *
 */
emxArray_real_T *emxCreate_real_T(int rows, int cols)
{
    emxArray_real_T *emx;
    int numEl;
    emxInit_real_T(&emx, 2);
    emx->size[0] = rows;
    numEl = rows * cols;
    emx->size[1] = cols;
    emx->data = (double *)calloc((unsigned int)numEl, sizeof(double));
    emx->numDimensions = 2;
    emx->allocatedSize = numEl;
    return emx;
}

/*
 * Arguments    : emxArray_real_T *emxArray
 * Return Type  : void
 */
void emxDestroyArray_real_T(emxArray_real_T *emxArray)
{
    emxFree_real_T(&emxArray);
}

/*
 * Arguments    : emxArray_real_T **pEmxArray
 *                int numDimensions
 * Return Type  : void
 */
void emxInitArray_real_T(emxArray_real_T **pEmxArray, int numDimensions)
{
    emxInit_real_T(pEmxArray, numDimensions);
}

/*
 * Arguments    : int numDimensions
 *                const int *size
 * Return Type  : emxArray_real32_T *
 */
emxArray_real32_T *emxCreateND_real32_T(int numDimensions, const int *size)
{
    emxArray_real32_T *emx;
    int numEl;
    int i;
    emxInit_real32_T(&emx, numDimensions);
    numEl = 1;
    for (i = 0; i < numDimensions; i++) {
        numEl *= size[i];
        emx->size[i] = size[i];
    }

    emx->data = (float *)calloc((unsigned int)numEl, sizeof(float));
    emx->numDimensions = numDimensions;
    emx->allocatedSize = numEl;
    return emx;
}

/*
 * Arguments    : float *data
 *                int numDimensions
 *                const int *size
 * Return Type  : emxArray_real32_T *
 */
emxArray_real32_T *emxCreateWrapperND_real32_T(float *data, int numDimensions,
                                               const int *size)
{
    emxArray_real32_T *emx;
    int numEl;
    int i;
    emxInit_real32_T(&emx, numDimensions);
    numEl = 1;
    for (i = 0; i < numDimensions; i++) {
        numEl *= size[i];
        emx->size[i] = size[i];
    }

    emx->data = data;
    emx->numDimensions = numDimensions;
    emx->allocatedSize = numEl;
    emx->canFreeData = false;
    return emx;
}

/*
 * Arguments    : float *data
 *                int rows
 *                int cols
 * Return Type  : emxArray_real32_T *
 */
emxArray_real32_T *emxCreateWrapper_real32_T(float *data, int rows, int cols)
{
    emxArray_real32_T *emx;
    emxInit_real32_T(&emx, 2);
    emx->size[0] = rows;
    emx->size[1] = cols;
    emx->data = data;
    emx->numDimensions = 2;
    emx->allocatedSize = rows * cols;
    emx->canFreeData = false;
    return emx;
}

/*
 * Arguments    : int rows
 *                int cols
 * Return Type  : emxArray_real32_T *
 */
emxArray_real32_T *emxCreate_real32_T(int rows, int cols)
{
    emxArray_real32_T *emx;
    int numEl;
    emxInit_real32_T(&emx, 2);
    emx->size[0] = rows;
    numEl = rows * cols;
    emx->size[1] = cols;
    emx->data = (float *)calloc((unsigned int)numEl, sizeof(float));
    emx->numDimensions = 2;
    emx->allocatedSize = numEl;
    return emx;
}

/*
 * Arguments    : emxArray_real32_T *emxArray
 * Return Type  : void
 */
void emxDestroyArray_real32_T(emxArray_real32_T *emxArray)
{
    emxFree_real32_T(&emxArray);
}

/*
 * Arguments    : emxArray_real32_T **pEmxArray
 *                int numDimensions
 * Return Type  : void
 */
void emxInitArray_real32_T(emxArray_real32_T **pEmxArray, int numDimensions)
{
    emxInit_real32_T(pEmxArray, numDimensions);
}

/*
 * Arguments    : int numDimensions
 *                const int *size
 * Return Type  : emxArray_uint8_T *
 */
emxArray_uint8_T *emxCreateND_uint8_T(int numDimensions, const int *size)
{
  emxArray_uint8_T *emx;
  int numEl;
  int i;
  emxInit_uint8_T(&emx, numDimensions);
  numEl = 1;
  for (i = 0; i < numDimensions; i++) {
    numEl *= size[i];
    emx->size[i] = size[i];
  }

  emx->data = (unsigned char *)calloc((unsigned int)numEl, sizeof(unsigned char));
  emx->numDimensions = numDimensions;
  emx->allocatedSize = numEl;
  return emx;
}

/*
 * Arguments    : unsigned char *data
 *                int numDimensions
 *                const int *size
 * Return Type  : emxArray_uint8_T *
 */
emxArray_uint8_T *emxCreateWrapperND_uint8_T(unsigned char *data, int
  numDimensions, const int *size)
{
  emxArray_uint8_T *emx;
  int numEl;
  int i;
  emxInit_uint8_T(&emx, numDimensions);
  numEl = 1;
  for (i = 0; i < numDimensions; i++) {
    numEl *= size[i];
    emx->size[i] = size[i];
  }

  emx->data = data;
  emx->numDimensions = numDimensions;
  emx->allocatedSize = numEl;
  emx->canFreeData = false;
  return emx;
}

/*
 * Arguments    : unsigned char *data
 *                int rows
 *                int cols
 * Return Type  : emxArray_uint8_T *
 */
emxArray_uint8_T *emxCreateWrapper_uint8_T(unsigned char *data, int rows, int
  cols)
{
  emxArray_uint8_T *emx;
  emxInit_uint8_T(&emx, 2);
  emx->size[0] = rows;
  emx->size[1] = cols;
  emx->data = data;
  emx->numDimensions = 2;
  emx->allocatedSize = rows * cols;
  emx->canFreeData = false;
  return emx;
}

/*
 * Arguments    : int rows
 *                int cols
 * Return Type  : emxArray_uint8_T *
 */
emxArray_uint8_T *emxCreate_uint8_T(int rows, int cols)
{
  emxArray_uint8_T *emx;
  int numEl;
  emxInit_uint8_T(&emx, 2);
  emx->size[0] = rows;
  numEl = rows * cols;
  emx->size[1] = cols;
  emx->data = (unsigned char *)calloc((unsigned int)numEl, sizeof(unsigned char));
  emx->numDimensions = 2;
  emx->allocatedSize = numEl;
  return emx;
}

/*
 * Arguments    : emxArray_uint8_T *emxArray
 * Return Type  : void
 */
void emxDestroyArray_uint8_T(emxArray_uint8_T *emxArray)
{
  emxFree_uint8_T(&emxArray);
}

/*
 * Arguments    : emxArray_uint8_T **pEmxArray
 *                int numDimensions
 * Return Type  : void
 */
void emxInitArray_uint8_T(emxArray_uint8_T **pEmxArray, int numDimensions)
{
  emxInit_uint8_T(pEmxArray, numDimensions);
}

/*
 * File trailer for birds_eye_view_emxAPI.c
 *
 * [EOF]
 */
