/*
 * Academic License - for use in teaching, academic research, and meeting
 * course requirements at degree granting institutions only.  Not for
 * government, commercial, or other organizational use.
 * File: generate_transformation_matrix.c
 *
 * MATLAB Coder version            : 4.3
 * C/C++ source code generated on  : 30-Apr-2020 14:45:14
 */

/* Include Files */
#include "generate_transformation_matrix.h"
#include "rt_nonfinite.h"
#include <math.h>
#include <string.h>

/* Type Definitions */
#ifndef typedef_c_vision_internal_calibration_C
#define typedef_c_vision_internal_calibration_C

typedef struct {
  double RadialDistortion[2];
  double TangentialDistortion[2];
  double NumRadialDistortionCoefficients;
} c_vision_internal_calibration_C;

#endif                                 /*typedef_c_vision_internal_calibration_C*/

#ifndef typedef_cameraIntrinsics
#define typedef_cameraIntrinsics

typedef struct {
  float FocalLength[2];
  float PrincipalPoint[2];
  double RadialDistortion[2];
  double TangentialDistortion[2];
  double Skew;
  float IntrinsicMatrix[9];
  c_vision_internal_calibration_C *CameraParameters;
} cameraIntrinsics;

#endif                                 /*typedef_cameraIntrinsics*/

#ifndef typedef_monoCamera
#define typedef_monoCamera

typedef struct {
  cameraIntrinsics Intrinsics;
  float Height;
  float Pitch;
  double Yaw;
  double Roll;
  double SensorLocation[2];
} monoCamera;

#endif                                 /*typedef_monoCamera*/

/* Variable Definitions */
static boolean_T isInitialized_generate_transformation_matrix = false;

/* Function Declarations */
static void birdsEyeView_birdsEyeView(const float sensor_Intrinsics_FocalLength
  [2], const float c_sensor_Intrinsics_PrincipalPo[2], const double
  c_sensor_Intrinsics_RadialDisto[2], const double
  c_sensor_Intrinsics_TangentialD[2], double sensor_Intrinsics_Skew, const float
  c_sensor_Intrinsics_IntrinsicMa[9], c_vision_internal_calibration_C
  *c_sensor_Intrinsics_CameraParam, float sensor_Height, float sensor_Pitch,
  double sensor_Yaw, double sensor_Roll, const double sensor_SensorLocation[2],
  const float outView[4], const float outImageSize[2], float this_OutputView[4],
  monoCamera *this_Sensor, float this_Scale[2]);
static void c_monoCamera_get_ImageToVehicle(const float
  this_Intrinsics_IntrinsicMatrix[9], float this_Height, float this_Pitch, float
  tform_T[9]);
static float rt_hypotf_snf(float u0, float u1);
static float xnrm2(int n, const float x_data[]);

/* Function Definitions */

/*
 * Arguments    : const float sensor_Intrinsics_FocalLength[2]
 *                const float c_sensor_Intrinsics_PrincipalPo[2]
 *                const double c_sensor_Intrinsics_RadialDisto[2]
 *                const double c_sensor_Intrinsics_TangentialD[2]
 *                double sensor_Intrinsics_Skew
 *                const float c_sensor_Intrinsics_IntrinsicMa[9]
 *                c_vision_internal_calibration_C *c_sensor_Intrinsics_CameraParam
 *                float sensor_Height
 *                float sensor_Pitch
 *                double sensor_Yaw
 *                double sensor_Roll
 *                const double sensor_SensorLocation[2]
 *                const float outView[4]
 *                const float outImageSize[2]
 *                float this_OutputView[4]
 *                monoCamera *this_Sensor
 *                float this_Scale[2]
 * Return Type  : void
 */
static void birdsEyeView_birdsEyeView(const float sensor_Intrinsics_FocalLength
  [2], const float c_sensor_Intrinsics_PrincipalPo[2], const double
  c_sensor_Intrinsics_RadialDisto[2], const double
  c_sensor_Intrinsics_TangentialD[2], double sensor_Intrinsics_Skew, const float
  c_sensor_Intrinsics_IntrinsicMa[9], c_vision_internal_calibration_C
  *c_sensor_Intrinsics_CameraParam, float sensor_Height, float sensor_Pitch,
  double sensor_Yaw, double sensor_Roll, const double sensor_SensorLocation[2],
  const float outView[4], const float outImageSize[2], float this_OutputView[4],
  monoCamera *this_Sensor, float this_Scale[2])
{
  int rankR;
  float worldHW[2];
  bool nanIdxHW[2];
  bool y;
  bool exitg1;
  int knt;
  signed char tmp_data[2];
  float A_data[2];
  float beta1;
  float b_A_data[2];
  float B_data[2];
  float atmp;
  float tau_data[1];
  int i;
  float wj;
  this_Sensor->Intrinsics.FocalLength[0] = sensor_Intrinsics_FocalLength[0];
  this_Sensor->Intrinsics.PrincipalPoint[0] = c_sensor_Intrinsics_PrincipalPo[0];
  this_Sensor->Intrinsics.RadialDistortion[0] = c_sensor_Intrinsics_RadialDisto
    [0];
  this_Sensor->Intrinsics.TangentialDistortion[0] =
    c_sensor_Intrinsics_TangentialD[0];
  this_Sensor->Intrinsics.FocalLength[1] = sensor_Intrinsics_FocalLength[1];
  this_Sensor->Intrinsics.PrincipalPoint[1] = c_sensor_Intrinsics_PrincipalPo[1];
  this_Sensor->Intrinsics.RadialDistortion[1] = c_sensor_Intrinsics_RadialDisto
    [1];
  this_Sensor->Intrinsics.TangentialDistortion[1] =
    c_sensor_Intrinsics_TangentialD[1];
  this_Sensor->Intrinsics.Skew = sensor_Intrinsics_Skew;
  for (rankR = 0; rankR < 9; rankR++) {
    this_Sensor->Intrinsics.IntrinsicMatrix[rankR] =
      c_sensor_Intrinsics_IntrinsicMa[rankR];
  }

  this_Sensor->Intrinsics.CameraParameters = c_sensor_Intrinsics_CameraParam;
  this_Sensor->Height = sensor_Height;
  this_Sensor->Pitch = sensor_Pitch;
  this_Sensor->Yaw = sensor_Yaw;
  this_Sensor->Roll = sensor_Roll;
  this_Sensor->SensorLocation[0] = sensor_SensorLocation[0];
  this_Sensor->SensorLocation[1] = sensor_SensorLocation[1];
  this_OutputView[0] = outView[0];
  this_OutputView[1] = outView[1];
  this_OutputView[2] = outView[2];
  this_OutputView[3] = outView[3];
  worldHW[0] = fabsf(outView[1] - outView[0]);
  nanIdxHW[0] = rtIsNaNF(outImageSize[0]);
  worldHW[1] = fabsf(outView[3] - outView[2]);
  nanIdxHW[1] = rtIsNaNF(outImageSize[1]);
  y = false;
  rankR = 0;
  exitg1 = false;
  while ((!exitg1) && (rankR < 2)) {
    if (nanIdxHW[rankR]) {
      y = true;
      exitg1 = true;
    } else {
      rankR++;
    }
  }

  if (!y) {
    this_Scale[0] = (outImageSize[1] - 1.0F) / worldHW[1];
    this_Scale[1] = (outImageSize[0] - 1.0F) / worldHW[0];
  } else {
    knt = 0;
    if (!nanIdxHW[0]) {
      knt = 1;
    }

    if (!nanIdxHW[1]) {
      knt++;
    }

    rankR = 0;
    if (!nanIdxHW[0]) {
      tmp_data[0] = 1;
      rankR = 1;
    }

    if (!nanIdxHW[1]) {
      tmp_data[rankR] = 2;
    }

    for (rankR = 0; rankR < knt; rankR++) {
      A_data[rankR] = outImageSize[tmp_data[rankR] - 1] - 1.0F;
    }

    if (knt == 0) {
      beta1 = 0.0F;
    } else if (1 == knt) {
      beta1 = A_data[0] / worldHW[tmp_data[0] - 1];
    } else {
      for (rankR = 0; rankR < 2; rankR++) {
        b_A_data[rankR] = worldHW[tmp_data[rankR] - 1];
      }

      if (0 <= knt - 1) {
        memcpy(&B_data[0], &A_data[0], knt * sizeof(float));
      }

      atmp = b_A_data[0];
      tau_data[0] = 0.0F;
      beta1 = xnrm2(1, b_A_data);
      if (beta1 != 0.0F) {
        beta1 = rt_hypotf_snf(b_A_data[0], beta1);
        if (b_A_data[0] >= 0.0F) {
          beta1 = -beta1;
        }

        if (fabsf(beta1) < 9.86076132E-32F) {
          knt = -1;
          do {
            knt++;
            b_A_data[1] *= 1.01412048E+31F;
            beta1 *= 1.01412048E+31F;
            atmp *= 1.01412048E+31F;
          } while (!(fabsf(beta1) >= 9.86076132E-32F));

          beta1 = rt_hypotf_snf(atmp, xnrm2(1, b_A_data));
          if (atmp >= 0.0F) {
            beta1 = -beta1;
          }

          tau_data[0] = (beta1 - atmp) / beta1;
          b_A_data[1] *= 1.0F / (atmp - beta1);
          for (rankR = 0; rankR <= knt; rankR++) {
            beta1 *= 9.86076132E-32F;
          }

          atmp = beta1;
        } else {
          tau_data[0] = (beta1 - b_A_data[0]) / beta1;
          b_A_data[1] *= 1.0F / (b_A_data[0] - beta1);
          atmp = beta1;
        }
      }

      rankR = 0;
      beta1 = fabsf(atmp);
      if (!(beta1 <= 2.38418579E-6F * beta1)) {
        rankR = 1;
      }

      beta1 = 0.0F;
      for (knt = 0; knt < 1; knt++) {
        if (tau_data[0] != 0.0F) {
          wj = B_data[0];
          for (i = 2; i < 3; i++) {
            wj += b_A_data[1] * B_data[1];
          }

          wj *= tau_data[0];
          if (wj != 0.0F) {
            B_data[0] -= wj;
            for (i = 2; i < 3; i++) {
              B_data[1] -= b_A_data[1] * wj;
            }
          }
        }
      }

      for (i = 0; i < rankR; i++) {
        beta1 = B_data[0];
      }

      for (knt = rankR; knt >= 1; knt--) {
        beta1 /= atmp;
      }
    }

    this_Scale[0] = beta1;
    this_Scale[1] = beta1;
  }
}

/*
 * Arguments    : const float this_Intrinsics_IntrinsicMatrix[9]
 *                float this_Height
 *                float this_Pitch
 *                float tform_T[9]
 * Return Type  : void
 */
static void c_monoCamera_get_ImageToVehicle(const float
  this_Intrinsics_IntrinsicMatrix[9], float this_Height, float this_Pitch, float
  tform_T[9])
{
  float a_tmp;
  float R_tmp_tmp;
  float fv[9];
  int p1;
  float f;
  static const float fv1[9] = { -6.12323426E-17F, -1.0F, -7.49879879E-33F, -1.0F,
    6.12323426E-17F, -1.22464685E-16F, 1.22464685E-16F, 0.0F, -1.0F };

  float f1;
  int p2;
  float fv2[9];
  signed char i;
  static const signed char iv[9] = { 1, 0, 0, 0, 1, 0, 0, 0, 1 };

  signed char i1;
  float fv3[9];
  float fv4[12];
  float camMatrix[12];
  int p3;
  int itmp;
  double y[9];
  double x[9];
  double absx11;
  double absx21;
  double absx31;
  a_tmp = 0.0174532924F * (90.0F - this_Pitch);
  R_tmp_tmp = sinf(a_tmp);
  a_tmp = cosf(a_tmp);
  fv[0] = 1.0F;
  fv[3] = 0.0F;
  fv[6] = 0.0F;
  fv[1] = 0.0F;
  fv[4] = a_tmp;
  fv[7] = -R_tmp_tmp;
  fv[2] = 0.0F;
  fv[5] = R_tmp_tmp;
  fv[8] = a_tmp;
  for (p1 = 0; p1 < 3; p1++) {
    f = fv1[p1 + 3];
    f1 = fv1[p1 + 6];
    for (p2 = 0; p2 < 3; p2++) {
      fv2[p1 + 3 * p2] = (fv1[p1] * fv[3 * p2] + f * fv[3 * p2 + 1]) + f1 * fv[3
        * p2 + 2];
    }
  }

  fv[0] = 1.0F;
  fv[3] = 0.0F;
  fv[6] = 0.0F;
  fv[1] = 0.0F;
  fv[4] = a_tmp;
  fv[7] = -R_tmp_tmp;
  fv[2] = 0.0F;
  fv[5] = R_tmp_tmp;
  fv[8] = a_tmp;
  for (p1 = 0; p1 < 3; p1++) {
    i = iv[p1 + 3];
    i1 = iv[p1 + 6];
    for (p2 = 0; p2 < 3; p2++) {
      fv3[p1 + 3 * p2] = ((float)iv[p1] * fv[3 * p2] + (float)i * fv[3 * p2 + 1])
        + (float)i1 * fv[3 * p2 + 2];
    }
  }

  for (p1 = 0; p1 < 3; p1++) {
    f = fv3[p1 + 3];
    f1 = fv3[p1 + 6];
    for (p2 = 0; p2 < 3; p2++) {
      fv[p1 + 3 * p2] = (fv3[p1] * (float)iv[3 * p2] + f * (float)iv[3 * p2 + 1])
        + f1 * (float)iv[3 * p2 + 2];
    }

    f = fv2[p1 + 3];
    f1 = fv2[p1 + 6];
    for (p2 = 0; p2 < 3; p2++) {
      fv3[p1 + 3 * p2] = (fv2[p1] * (float)iv[3 * p2] + f * (float)iv[3 * p2 + 1])
        + f1 * (float)iv[3 * p2 + 2];
    }
  }

  for (p1 = 0; p1 < 3; p1++) {
    p2 = p1 << 2;
    fv4[p2] = fv3[3 * p1];
    p3 = 3 * p1 + 1;
    fv4[p2 + 1] = fv3[p3];
    itmp = 3 * p1 + 2;
    fv4[p2 + 2] = fv3[itmp];
    fv4[p2 + 3] = (0.0F * fv[3 * p1] + 0.0F * fv[p3]) + this_Height * fv[itmp];
  }

  for (p1 = 0; p1 < 4; p1++) {
    f = fv4[p1 + 4];
    f1 = fv4[p1 + 8];
    for (p2 = 0; p2 < 3; p2++) {
      camMatrix[p1 + (p2 << 2)] = (fv4[p1] * this_Intrinsics_IntrinsicMatrix[3 *
        p2] + f * this_Intrinsics_IntrinsicMatrix[3 * p2 + 1]) + f1 *
        this_Intrinsics_IntrinsicMatrix[3 * p2 + 2];
    }
  }

  tform_T[0] = camMatrix[0];
  tform_T[1] = camMatrix[1];
  tform_T[2] = camMatrix[3];
  tform_T[3] = camMatrix[4];
  tform_T[4] = camMatrix[5];
  tform_T[5] = camMatrix[7];
  tform_T[6] = camMatrix[8];
  tform_T[7] = camMatrix[9];
  tform_T[8] = camMatrix[11];
  for (p1 = 0; p1 < 9; p1++) {
    y[p1] = tform_T[p1];
    x[p1] = tform_T[p1];
  }

  p1 = 0;
  p2 = 3;
  p3 = 6;
  absx11 = fabs(y[0]);
  absx21 = fabs(y[1]);
  absx31 = fabs(y[2]);
  if ((absx21 > absx11) && (absx21 > absx31)) {
    p1 = 3;
    p2 = 0;
    x[0] = y[1];
    x[1] = y[0];
    x[3] = y[4];
    x[4] = y[3];
    x[6] = y[7];
    x[7] = y[6];
  } else {
    if (absx31 > absx11) {
      p1 = 6;
      p3 = 0;
      x[0] = y[2];
      x[2] = y[0];
      x[3] = y[5];
      x[5] = y[3];
      x[6] = y[8];
      x[8] = y[6];
    }
  }

  x[1] /= x[0];
  x[2] /= x[0];
  x[4] -= x[1] * x[3];
  x[5] -= x[2] * x[3];
  x[7] -= x[1] * x[6];
  x[8] -= x[2] * x[6];
  if (fabs(x[5]) > fabs(x[4])) {
    itmp = p2;
    p2 = p3;
    p3 = itmp;
    absx11 = x[1];
    x[1] = x[2];
    x[2] = absx11;
    absx11 = x[4];
    x[4] = x[5];
    x[5] = absx11;
    absx11 = x[7];
    x[7] = x[8];
    x[8] = absx11;
  }

  x[5] /= x[4];
  x[8] -= x[5] * x[7];
  absx11 = (x[5] * x[1] - x[2]) / x[8];
  absx21 = -(x[1] + x[7] * absx11) / x[4];
  y[p1] = ((1.0 - x[3] * absx21) - x[6] * absx11) / x[0];
  y[p1 + 1] = absx21;
  y[p1 + 2] = absx11;
  absx11 = -x[5] / x[8];
  absx21 = (1.0 - x[7] * absx11) / x[4];
  y[p2] = -(x[3] * absx21 + x[6] * absx11) / x[0];
  y[p2 + 1] = absx21;
  y[p2 + 2] = absx11;
  absx11 = 1.0 / x[8];
  absx21 = -x[7] * absx11 / x[4];
  y[p3] = -(x[3] * absx21 + x[6] * absx11) / x[0];
  y[p3 + 1] = absx21;
  y[p3 + 2] = absx11;
  for (p1 = 0; p1 < 9; p1++) {
    tform_T[p1] = (float)y[p1];
  }
}

/*
 * Arguments    : float u0
 *                float u1
 * Return Type  : float
 */
static float rt_hypotf_snf(float u0, float u1)
{
  float y;
  float a;
  a = fabsf(u0);
  y = fabsf(u1);
  if (a < y) {
    a /= y;
    y *= sqrtf(a * a + 1.0F);
  } else if (a > y) {
    y /= a;
    y = a * sqrtf(y * y + 1.0F);
  } else {
    if (!rtIsNaNF(y)) {
      y = a * 1.41421354F;
    }
  }

  return y;
}

/*
 * Arguments    : int n
 *                const float x_data[]
 * Return Type  : float
 */
static float xnrm2(int n, const float x_data[])
{
  float y;
  float scale;
  float absxk;
  y = 0.0F;
  if (n >= 1) {
    if (n == 1) {
      y = fabsf(x_data[1]);
    } else {
      scale = 1.29246971E-26F;
      absxk = fabsf(x_data[1]);
      if (absxk > 1.29246971E-26F) {
        y = 1.0F;
        scale = absxk;
      } else {
        absxk /= 1.29246971E-26F;
        y = absxk * absxk;
      }

      y = scale * sqrtf(y);
    }
  }

  return y;
}

/*
 * Arguments    : const float focalLength[2]
 *                const float principalPoint[2]
 *                const float imageSize[2]
 *                float height
 *                float pitch
 *                float distAhead
 *                float spaceToOneSide
 *                float bottomOffset
 *                float outWidth
 *                float transformation_matrix[9]
 *                float image_to_vehicle_matrix[9]
 *                float outSize[2]
 * Return Type  : void
 */
void generate_transformation_matrix(const float focalLength[2], const float
  principalPoint[2], const float imageSize[2], float height, float pitch, float
  distAhead, float spaceToOneSide, float bottomOffset, float outWidth, float
  transformation_matrix[9], float image_to_vehicle_matrix[9], float outSize[2])
{
  double c_cameraObject_Intrinsics_Radia[2];
  double c_cameraObject_Intrinsics_Tange[2];
  float vehicleHomography[9];
  c_vision_internal_calibration_C lobj_0;
  double cameraObject_SensorLocation[2];
  float outView[4];
  float birdsEye_OutputView[4];
  monoCamera birdsEye_Sensor;
  float birdsEye_Scale[2];
  int p3;
  float c_birdsEye_Sensor_Intrinsics_In[9];
  int p2;
  float worldHW[2];
  bool b;
  float outDimFrac_data[2];
  float scale;
  signed char tmp_data[2];
  int p1;
  float f;
  float b_image_to_vehicle_matrix[9];
  static const signed char b_b[9] = { 0, -1, 0, -1, 0, 0, 0, 0, 1 };

  double y[9];
  float toOriginalImage_T[9];
  double x[9];
  double absx11;
  double absx21;
  double absx31;
  int itmp;
  if (isInitialized_generate_transformation_matrix == false) {
    generate_transformation_matrix_initialize();
  }

  (void)imageSize;
  c_cameraObject_Intrinsics_Radia[0] = 0.0;
  c_cameraObject_Intrinsics_Tange[0] = 0.0;
  c_cameraObject_Intrinsics_Radia[1] = 0.0;
  c_cameraObject_Intrinsics_Tange[1] = 0.0;
  vehicleHomography[0] = focalLength[0];
  vehicleHomography[3] = 0.0F;
  vehicleHomography[6] = 0.0F;
  vehicleHomography[1] = 0.0F;
  vehicleHomography[4] = focalLength[1];
  vehicleHomography[7] = 0.0F;
  vehicleHomography[2] = principalPoint[0];
  vehicleHomography[5] = principalPoint[1];
  vehicleHomography[8] = 1.0F;
  lobj_0.RadialDistortion[0] = 0.0;
  lobj_0.RadialDistortion[1] = 0.0;
  lobj_0.TangentialDistortion[0] = 0.0;
  lobj_0.TangentialDistortion[1] = 0.0;
  lobj_0.NumRadialDistortionCoefficients = 2.0;
  cameraObject_SensorLocation[0] = 0.0;
  cameraObject_SensorLocation[1] = 0.0;
  outView[0] = bottomOffset;
  outView[1] = distAhead;
  outView[2] = -spaceToOneSide;
  outView[3] = spaceToOneSide;
  outSize[0] = rtNaNF;
  outSize[1] = outWidth;
  birdsEyeView_birdsEyeView(focalLength, principalPoint,
    c_cameraObject_Intrinsics_Radia, c_cameraObject_Intrinsics_Tange, 0.0,
    vehicleHomography, &lobj_0, height, pitch, 0.0, 0.0,
    cameraObject_SensorLocation, outView, outSize, birdsEye_OutputView,
    &birdsEye_Sensor, birdsEye_Scale);
  for (p3 = 0; p3 < 9; p3++) {
    c_birdsEye_Sensor_Intrinsics_In[p3] =
      birdsEye_Sensor.Intrinsics.IntrinsicMatrix[p3];
  }

  /*  -1 here causes y to become x and reverses the axis direction */
  /*  x becomes y and reverses axis direction */
  /*  no translation */
  c_monoCamera_get_ImageToVehicle(c_birdsEye_Sensor_Intrinsics_In,
    birdsEye_Sensor.Height, birdsEye_Sensor.Pitch, image_to_vehicle_matrix);
  p2 = 0;
  worldHW[0] = fabsf(distAhead - bottomOffset);
  b = rtIsNaNF(outWidth);
  worldHW[1] = fabsf(spaceToOneSide - (-spaceToOneSide));
  if (!b) {
    p2 = 1;
  }

  if (0 <= p2 - 1) {
    outDimFrac_data[0] = outWidth - 1.0F;
  }

  if (p2 == 0) {
    scale = 0.0F;
  } else {
    scale = outDimFrac_data[0] / worldHW[1];
  }

  p2 = 1;
  if (b) {
    p2 = 2;
  }

  tmp_data[0] = 1;
  if (b) {
    tmp_data[1] = 2;
  }

  for (p3 = 0; p3 < p2; p3++) {
    outDimFrac_data[p3] = scale * worldHW[tmp_data[p3] - 1];
  }

  for (p1 = 0; p1 < p2; p1++) {
    outDimFrac_data[p1] = roundf(outDimFrac_data[p1]);
  }

  p1 = p2 - 1;
  for (p3 = 0; p3 <= p1; p3++) {
    outDimFrac_data[p3]++;
  }

  outSize[0] = outDimFrac_data[0];
  if (b) {
    outSize[1] = outDimFrac_data[1];
  }

  /*  X,Y translation in pixels */
  /*  +1 for placing origin at (1,1) */
  vehicleHomography[0] = scale;
  vehicleHomography[3] = 0.0F;
  vehicleHomography[6] = 0.0F;
  vehicleHomography[1] = 0.0F;
  vehicleHomography[4] = scale;
  vehicleHomography[7] = 0.0F;
  vehicleHomography[2] = scale * spaceToOneSide + 1.0F;
  vehicleHomography[5] = scale * distAhead + 1.0F;
  vehicleHomography[8] = 1.0F;
  for (p3 = 0; p3 < 3; p3++) {
    scale = image_to_vehicle_matrix[p3 + 3];
    f = image_to_vehicle_matrix[p3 + 6];
    for (p1 = 0; p1 < 3; p1++) {
      b_image_to_vehicle_matrix[p3 + 3 * p1] = (image_to_vehicle_matrix[p3] *
        (float)b_b[3 * p1] + scale * (float)b_b[3 * p1 + 1]) + f * (float)b_b[3 *
        p1 + 2];
    }

    scale = b_image_to_vehicle_matrix[p3 + 3];
    f = b_image_to_vehicle_matrix[p3 + 6];
    for (p1 = 0; p1 < 3; p1++) {
      transformation_matrix[p3 + 3 * p1] = (b_image_to_vehicle_matrix[p3] *
        vehicleHomography[3 * p1] + scale * vehicleHomography[3 * p1 + 1]) + f *
        vehicleHomography[3 * p1 + 2];
    }
  }

  c_monoCamera_get_ImageToVehicle(c_birdsEye_Sensor_Intrinsics_In,
    birdsEye_Sensor.Height, birdsEye_Sensor.Pitch, image_to_vehicle_matrix);
  vehicleHomography[0] = birdsEye_Scale[0];
  vehicleHomography[3] = 0.0F;
  vehicleHomography[6] = 0.0F;
  vehicleHomography[1] = 0.0F;
  vehicleHomography[4] = birdsEye_Scale[1];
  vehicleHomography[7] = 0.0F;
  vehicleHomography[2] = birdsEye_Scale[0] * birdsEye_OutputView[3] + 1.0F;
  vehicleHomography[5] = birdsEye_Scale[1] * birdsEye_OutputView[1] + 1.0F;
  vehicleHomography[8] = 1.0F;
  for (p3 = 0; p3 < 3; p3++) {
    scale = image_to_vehicle_matrix[p3 + 3];
    f = image_to_vehicle_matrix[p3 + 6];
    for (p1 = 0; p1 < 3; p1++) {
      b_image_to_vehicle_matrix[p3 + 3 * p1] = (image_to_vehicle_matrix[p3] *
        (float)b_b[3 * p1] + scale * (float)b_b[3 * p1 + 1]) + f * (float)b_b[3 *
        p1 + 2];
    }

    scale = b_image_to_vehicle_matrix[p3 + 3];
    f = b_image_to_vehicle_matrix[p3 + 6];
    for (p1 = 0; p1 < 3; p1++) {
      toOriginalImage_T[p3 + 3 * p1] = (b_image_to_vehicle_matrix[p3] *
        vehicleHomography[3 * p1] + scale * vehicleHomography[3 * p1 + 1]) + f *
        vehicleHomography[3 * p1 + 2];
    }
  }

  for (p3 = 0; p3 < 9; p3++) {
    y[p3] = toOriginalImage_T[p3];
    x[p3] = toOriginalImage_T[p3];
  }

  p1 = 0;
  p2 = 3;
  p3 = 6;
  absx11 = fabs(y[0]);
  absx21 = fabs(y[1]);
  absx31 = fabs(y[2]);
  if ((absx21 > absx11) && (absx21 > absx31)) {
    p1 = 3;
    p2 = 0;
    x[0] = y[1];
    x[1] = y[0];
    x[3] = y[4];
    x[4] = y[3];
    x[6] = y[7];
    x[7] = y[6];
  } else {
    if (absx31 > absx11) {
      p1 = 6;
      p3 = 0;
      x[0] = y[2];
      x[2] = y[0];
      x[3] = y[5];
      x[5] = y[3];
      x[6] = y[8];
      x[8] = y[6];
    }
  }

  x[1] /= x[0];
  x[2] /= x[0];
  x[4] -= x[1] * x[3];
  x[5] -= x[2] * x[3];
  x[7] -= x[1] * x[6];
  x[8] -= x[2] * x[6];
  if (fabs(x[5]) > fabs(x[4])) {
    itmp = p2;
    p2 = p3;
    p3 = itmp;
    absx11 = x[1];
    x[1] = x[2];
    x[2] = absx11;
    absx11 = x[4];
    x[4] = x[5];
    x[5] = absx11;
    absx11 = x[7];
    x[7] = x[8];
    x[8] = absx11;
  }

  x[5] /= x[4];
  x[8] -= x[5] * x[7];
  absx11 = (x[5] * x[1] - x[2]) / x[8];
  absx21 = -(x[1] + x[7] * absx11) / x[4];
  y[p1] = ((1.0 - x[3] * absx21) - x[6] * absx11) / x[0];
  y[p1 + 1] = absx21;
  y[p1 + 2] = absx11;
  absx11 = -x[5] / x[8];
  absx21 = (1.0 - x[7] * absx11) / x[4];
  y[p2] = -(x[3] * absx21 + x[6] * absx11) / x[0];
  y[p2 + 1] = absx21;
  y[p2 + 2] = absx11;
  absx11 = 1.0 / x[8];
  absx21 = -x[7] * absx11 / x[4];
  y[p3] = -(x[3] * absx21 + x[6] * absx11) / x[0];
  y[p3 + 1] = absx21;
  y[p3 + 2] = absx11;
  c_monoCamera_get_ImageToVehicle(c_birdsEye_Sensor_Intrinsics_In,
    birdsEye_Sensor.Height, birdsEye_Sensor.Pitch, image_to_vehicle_matrix);
  for (p3 = 0; p3 < 9; p3++) {
    toOriginalImage_T[p3] = (float)y[p3];
    vehicleHomography[p3] = image_to_vehicle_matrix[p3];
  }

  for (p3 = 0; p3 < 3; p3++) {
    scale = toOriginalImage_T[p3 + 3];
    f = toOriginalImage_T[p3 + 6];
    for (p1 = 0; p1 < 3; p1++) {
      image_to_vehicle_matrix[p3 + 3 * p1] = (toOriginalImage_T[p3] *
        vehicleHomography[3 * p1] + scale * vehicleHomography[3 * p1 + 1]) + f *
        vehicleHomography[3 * p1 + 2];
    }
  }
}

/*
 * Arguments    : void
 * Return Type  : void
 */
void generate_transformation_matrix_initialize(void)
{
  rt_InitInfAndNaN();
  isInitialized_generate_transformation_matrix = true;
}

/*
 * Arguments    : void
 * Return Type  : void
 */
void generate_transformation_matrix_terminate(void)
{
  /* (no terminate code required) */
  isInitialized_generate_transformation_matrix = false;
}

/*
 * File trailer for generate_transformation_matrix.c
 *
 * [EOF]
 */
