/*
 * Academic License - for use in teaching, academic research, and meeting
 * course requirements at degree granting institutions only.  Not for
 * government, commercial, or other organizational use.
 * File: generate_transformation_matrix_inverse.c
 *
 * MATLAB Coder version            : 4.3
 * C/C++ source code generated on  : 11-Jan-2020 15:51:26
 */

/* Include Files */
#include "generate_transformation_matrix_inverse.h"
#include "rt_nonfinite.h"
#include <math.h>

/* Type Definitions */
#ifndef typedef_c_vision_internal_calibration_C
#define typedef_c_vision_internal_calibration_C

typedef struct {
  double RadialDistortion[2];
  double TangentialDistortion[2];
  double NumRadialDistortionCoefficients;
} c_vision_internal_calibration_C;

#endif                                 /*typedef_c_vision_internal_calibration_C*/

#ifndef typedef_cameraIntrinsics
#define typedef_cameraIntrinsics

typedef struct {
  float FocalLength[2];
  float PrincipalPoint[2];
  double RadialDistortion[2];
  double TangentialDistortion[2];
  double Skew;
  float IntrinsicMatrix[9];
  c_vision_internal_calibration_C *CameraParameters;
} cameraIntrinsics;

#endif                                 /*typedef_cameraIntrinsics*/

#ifndef typedef_monoCamera
#define typedef_monoCamera

typedef struct {
  cameraIntrinsics Intrinsics;
  float Height;
  float Pitch;
  double Yaw;
  double Roll;
  double SensorLocation[2];
} monoCamera;

#endif                                 /*typedef_monoCamera*/

/* Variable Definitions */
static boolean_T isInitialized_generate_transformation_matrix_inverse = false;

/* Function Declarations */
static void birdsEyeView_birdsEyeView(const float sensor_Intrinsics_FocalLength
  [2], const float c_sensor_Intrinsics_PrincipalPo[2], const double
  c_sensor_Intrinsics_RadialDisto[2], const double
  c_sensor_Intrinsics_TangentialD[2], double sensor_Intrinsics_Skew, const float
  c_sensor_Intrinsics_IntrinsicMa[9], c_vision_internal_calibration_C
  *c_sensor_Intrinsics_CameraParam, float sensor_Height, float sensor_Pitch,
  double sensor_Yaw, double sensor_Roll, const double sensor_SensorLocation[2],
  const float outView[4], float this_OutputView[4], monoCamera *this_Sensor);
static void c_monoCamera_get_ImageToVehicle(const float
  this_Intrinsics_IntrinsicMatrix[9], float this_Height, float this_Pitch, float
  tform_T[9]);

/* Function Definitions */

/*
 * Arguments    : const float sensor_Intrinsics_FocalLength[2]
 *                const float c_sensor_Intrinsics_PrincipalPo[2]
 *                const double c_sensor_Intrinsics_RadialDisto[2]
 *                const double c_sensor_Intrinsics_TangentialD[2]
 *                double sensor_Intrinsics_Skew
 *                const float c_sensor_Intrinsics_IntrinsicMa[9]
 *                c_vision_internal_calibration_C *c_sensor_Intrinsics_CameraParam
 *                float sensor_Height
 *                float sensor_Pitch
 *                double sensor_Yaw
 *                double sensor_Roll
 *                const double sensor_SensorLocation[2]
 *                const float outView[4]
 *                float this_OutputView[4]
 *                monoCamera *this_Sensor
 * Return Type  : void
 */
static void birdsEyeView_birdsEyeView(const float sensor_Intrinsics_FocalLength
  [2], const float c_sensor_Intrinsics_PrincipalPo[2], const double
  c_sensor_Intrinsics_RadialDisto[2], const double
  c_sensor_Intrinsics_TangentialD[2], double sensor_Intrinsics_Skew, const float
  c_sensor_Intrinsics_IntrinsicMa[9], c_vision_internal_calibration_C
  *c_sensor_Intrinsics_CameraParam, float sensor_Height, float sensor_Pitch,
  double sensor_Yaw, double sensor_Roll, const double sensor_SensorLocation[2],
  const float outView[4], float this_OutputView[4], monoCamera *this_Sensor)
{
  int i;
  this_Sensor->Intrinsics.FocalLength[0] = sensor_Intrinsics_FocalLength[0];
  this_Sensor->Intrinsics.PrincipalPoint[0] = c_sensor_Intrinsics_PrincipalPo[0];
  this_Sensor->Intrinsics.RadialDistortion[0] = c_sensor_Intrinsics_RadialDisto
    [0];
  this_Sensor->Intrinsics.TangentialDistortion[0] =
    c_sensor_Intrinsics_TangentialD[0];
  this_Sensor->Intrinsics.FocalLength[1] = sensor_Intrinsics_FocalLength[1];
  this_Sensor->Intrinsics.PrincipalPoint[1] = c_sensor_Intrinsics_PrincipalPo[1];
  this_Sensor->Intrinsics.RadialDistortion[1] = c_sensor_Intrinsics_RadialDisto
    [1];
  this_Sensor->Intrinsics.TangentialDistortion[1] =
    c_sensor_Intrinsics_TangentialD[1];
  this_Sensor->Intrinsics.Skew = sensor_Intrinsics_Skew;
  for (i = 0; i < 9; i++) {
    this_Sensor->Intrinsics.IntrinsicMatrix[i] =
      c_sensor_Intrinsics_IntrinsicMa[i];
  }

  this_Sensor->Intrinsics.CameraParameters = c_sensor_Intrinsics_CameraParam;
  this_Sensor->Height = sensor_Height;
  this_Sensor->Pitch = sensor_Pitch;
  this_Sensor->Yaw = sensor_Yaw;
  this_Sensor->Roll = sensor_Roll;
  this_Sensor->SensorLocation[0] = sensor_SensorLocation[0];
  this_Sensor->SensorLocation[1] = sensor_SensorLocation[1];
  this_OutputView[0] = outView[0];
  this_OutputView[1] = outView[1];
  this_OutputView[2] = outView[2];
  this_OutputView[3] = outView[3];
}

/*
 * Arguments    : const float this_Intrinsics_IntrinsicMatrix[9]
 *                float this_Height
 *                float this_Pitch
 *                float tform_T[9]
 * Return Type  : void
 */
static void c_monoCamera_get_ImageToVehicle(const float
  this_Intrinsics_IntrinsicMatrix[9], float this_Height, float this_Pitch, float
  tform_T[9])
{
  float a_tmp;
  float R_tmp_tmp;
  float fv[9];
  int p1;
  float f;
  static const float fv1[9] = { -6.12323426E-17F, -1.0F, -7.49879879E-33F, -1.0F,
    6.12323426E-17F, -1.22464685E-16F, 1.22464685E-16F, 0.0F, -1.0F };

  float f1;
  int p2;
  float fv2[9];
  signed char i;
  static const signed char iv[9] = { 1, 0, 0, 0, 1, 0, 0, 0, 1 };

  signed char i1;
  float fv3[9];
  float fv4[12];
  float camMatrix[12];
  int p3;
  int itmp;
  double y[9];
  double x[9];
  double absx11;
  double absx21;
  double absx31;
  a_tmp = 0.0174532924F * (90.0F - this_Pitch);
  R_tmp_tmp = sinf(a_tmp);
  a_tmp = cosf(a_tmp);
  fv[0] = 1.0F;
  fv[3] = 0.0F;
  fv[6] = 0.0F;
  fv[1] = 0.0F;
  fv[4] = a_tmp;
  fv[7] = -R_tmp_tmp;
  fv[2] = 0.0F;
  fv[5] = R_tmp_tmp;
  fv[8] = a_tmp;
  for (p1 = 0; p1 < 3; p1++) {
    f = fv1[p1 + 3];
    f1 = fv1[p1 + 6];
    for (p2 = 0; p2 < 3; p2++) {
      fv2[p1 + 3 * p2] = (fv1[p1] * fv[3 * p2] + f * fv[3 * p2 + 1]) + f1 * fv[3
        * p2 + 2];
    }
  }

  fv[0] = 1.0F;
  fv[3] = 0.0F;
  fv[6] = 0.0F;
  fv[1] = 0.0F;
  fv[4] = a_tmp;
  fv[7] = -R_tmp_tmp;
  fv[2] = 0.0F;
  fv[5] = R_tmp_tmp;
  fv[8] = a_tmp;
  for (p1 = 0; p1 < 3; p1++) {
    i = iv[p1 + 3];
    i1 = iv[p1 + 6];
    for (p2 = 0; p2 < 3; p2++) {
      fv3[p1 + 3 * p2] = ((float)iv[p1] * fv[3 * p2] + (float)i * fv[3 * p2 + 1])
        + (float)i1 * fv[3 * p2 + 2];
    }
  }

  for (p1 = 0; p1 < 3; p1++) {
    f = fv3[p1 + 3];
    f1 = fv3[p1 + 6];
    for (p2 = 0; p2 < 3; p2++) {
      fv[p1 + 3 * p2] = (fv3[p1] * (float)iv[3 * p2] + f * (float)iv[3 * p2 + 1])
        + f1 * (float)iv[3 * p2 + 2];
    }

    f = fv2[p1 + 3];
    f1 = fv2[p1 + 6];
    for (p2 = 0; p2 < 3; p2++) {
      fv3[p1 + 3 * p2] = (fv2[p1] * (float)iv[3 * p2] + f * (float)iv[3 * p2 + 1])
        + f1 * (float)iv[3 * p2 + 2];
    }
  }

  for (p1 = 0; p1 < 3; p1++) {
    p2 = p1 << 2;
    fv4[p2] = fv3[3 * p1];
    p3 = 3 * p1 + 1;
    fv4[p2 + 1] = fv3[p3];
    itmp = 3 * p1 + 2;
    fv4[p2 + 2] = fv3[itmp];
    fv4[p2 + 3] = (0.0F * fv[3 * p1] + 0.0F * fv[p3]) + this_Height * fv[itmp];
  }

  for (p1 = 0; p1 < 4; p1++) {
    f = fv4[p1 + 4];
    f1 = fv4[p1 + 8];
    for (p2 = 0; p2 < 3; p2++) {
      camMatrix[p1 + (p2 << 2)] = (fv4[p1] * this_Intrinsics_IntrinsicMatrix[3 *
        p2] + f * this_Intrinsics_IntrinsicMatrix[3 * p2 + 1]) + f1 *
        this_Intrinsics_IntrinsicMatrix[3 * p2 + 2];
    }
  }

  tform_T[0] = camMatrix[0];
  tform_T[1] = camMatrix[1];
  tform_T[2] = camMatrix[3];
  tform_T[3] = camMatrix[4];
  tform_T[4] = camMatrix[5];
  tform_T[5] = camMatrix[7];
  tform_T[6] = camMatrix[8];
  tform_T[7] = camMatrix[9];
  tform_T[8] = camMatrix[11];
  for (p1 = 0; p1 < 9; p1++) {
    y[p1] = tform_T[p1];
    x[p1] = tform_T[p1];
  }

  p1 = 0;
  p2 = 3;
  p3 = 6;
  absx11 = fabs(y[0]);
  absx21 = fabs(y[1]);
  absx31 = fabs(y[2]);
  if ((absx21 > absx11) && (absx21 > absx31)) {
    p1 = 3;
    p2 = 0;
    x[0] = y[1];
    x[1] = y[0];
    x[3] = y[4];
    x[4] = y[3];
    x[6] = y[7];
    x[7] = y[6];
  } else {
    if (absx31 > absx11) {
      p1 = 6;
      p3 = 0;
      x[0] = y[2];
      x[2] = y[0];
      x[3] = y[5];
      x[5] = y[3];
      x[6] = y[8];
      x[8] = y[6];
    }
  }

  x[1] /= x[0];
  x[2] /= x[0];
  x[4] -= x[1] * x[3];
  x[5] -= x[2] * x[3];
  x[7] -= x[1] * x[6];
  x[8] -= x[2] * x[6];
  if (fabs(x[5]) > fabs(x[4])) {
    itmp = p2;
    p2 = p3;
    p3 = itmp;
    absx11 = x[1];
    x[1] = x[2];
    x[2] = absx11;
    absx11 = x[4];
    x[4] = x[5];
    x[5] = absx11;
    absx11 = x[7];
    x[7] = x[8];
    x[8] = absx11;
  }

  x[5] /= x[4];
  x[8] -= x[5] * x[7];
  absx11 = (x[5] * x[1] - x[2]) / x[8];
  absx21 = -(x[1] + x[7] * absx11) / x[4];
  y[p1] = ((1.0 - x[3] * absx21) - x[6] * absx11) / x[0];
  y[p1 + 1] = absx21;
  y[p1 + 2] = absx11;
  absx11 = -x[5] / x[8];
  absx21 = (1.0 - x[7] * absx11) / x[4];
  y[p2] = -(x[3] * absx21 + x[6] * absx11) / x[0];
  y[p2 + 1] = absx21;
  y[p2 + 2] = absx11;
  absx11 = 1.0 / x[8];
  absx21 = -x[7] * absx11 / x[4];
  y[p3] = -(x[3] * absx21 + x[6] * absx11) / x[0];
  y[p3 + 1] = absx21;
  y[p3 + 2] = absx11;
  for (p1 = 0; p1 < 9; p1++) {
    tform_T[p1] = (float)y[p1];
  }
}

/*
 * Arguments    : const float focalLength[2]
 *                const float principalPoint[2]
 *                const float imageSize[2]
 *                float height
 *                float pitch
 *                float distAhead
 *                float spaceToOneSide
 *                float bottomOffset
 *                float outWidth
 *                float transformation_matrix[9]
 *                float outSize[2]
 * Return Type  : void
 */
void generate_transformation_matrix_inverse(const float focalLength[2], const
  float principalPoint[2], const float imageSize[2], float height, float pitch,
  float distAhead, float spaceToOneSide, float bottomOffset, float outWidth,
  float transformation_matrix[9], float outSize[2])
{
  double c_cameraObject_Intrinsics_Radia[2];
  double c_cameraObject_Intrinsics_Tange[2];
  float c_cameraObject_Intrinsics_Intri[9];
  c_vision_internal_calibration_C lobj_0;
  double cameraObject_SensorLocation[2];
  float outView[4];
  float expl_temp[4];
  monoCamera birdsEye_Sensor;
  int p3;
  float t0_T[9];
  int p2;
  float worldHW[2];
  bool b;
  float outDimFrac_data[2];
  float scale;
  signed char tmp_data[2];
  int p1;
  float absx21;
  float b_t0_T[9];
  static const signed char b_b[9] = { 0, -1, 0, -1, 0, 0, 0, 0, 1 };

  float absx31;
  int itmp;
  if (isInitialized_generate_transformation_matrix_inverse == false) {
    generate_transformation_matrix_inverse_initialize();
  }

  (void)imageSize;
  c_cameraObject_Intrinsics_Radia[0] = 0.0;
  c_cameraObject_Intrinsics_Tange[0] = 0.0;
  c_cameraObject_Intrinsics_Radia[1] = 0.0;
  c_cameraObject_Intrinsics_Tange[1] = 0.0;
  c_cameraObject_Intrinsics_Intri[0] = focalLength[0];
  c_cameraObject_Intrinsics_Intri[3] = 0.0F;
  c_cameraObject_Intrinsics_Intri[6] = 0.0F;
  c_cameraObject_Intrinsics_Intri[1] = 0.0F;
  c_cameraObject_Intrinsics_Intri[4] = focalLength[1];
  c_cameraObject_Intrinsics_Intri[7] = 0.0F;
  c_cameraObject_Intrinsics_Intri[2] = principalPoint[0];
  c_cameraObject_Intrinsics_Intri[5] = principalPoint[1];
  c_cameraObject_Intrinsics_Intri[8] = 1.0F;
  lobj_0.RadialDistortion[0] = 0.0;
  lobj_0.RadialDistortion[1] = 0.0;
  lobj_0.TangentialDistortion[0] = 0.0;
  lobj_0.TangentialDistortion[1] = 0.0;
  lobj_0.NumRadialDistortionCoefficients = 2.0;
  cameraObject_SensorLocation[0] = 0.0;
  cameraObject_SensorLocation[1] = 0.0;
  outView[0] = bottomOffset;
  outView[1] = distAhead;
  outView[2] = -spaceToOneSide;
  outView[3] = spaceToOneSide;
  outSize[1] = outWidth;
  birdsEyeView_birdsEyeView(focalLength, principalPoint,
    c_cameraObject_Intrinsics_Radia, c_cameraObject_Intrinsics_Tange, 0.0,
    c_cameraObject_Intrinsics_Intri, &lobj_0, height, pitch, 0.0, 0.0,
    cameraObject_SensorLocation, outView, expl_temp, &birdsEye_Sensor);
  for (p3 = 0; p3 < 9; p3++) {
    c_cameraObject_Intrinsics_Intri[p3] =
      birdsEye_Sensor.Intrinsics.IntrinsicMatrix[p3];
  }

  /*  -1 here causes y to become x and reverses the axis direction */
  /*  x becomes y and reverses axis direction */
  /*  no translation */
  c_monoCamera_get_ImageToVehicle(c_cameraObject_Intrinsics_Intri,
    birdsEye_Sensor.Height, birdsEye_Sensor.Pitch, t0_T);
  p2 = 0;
  worldHW[0] = fabsf(distAhead - bottomOffset);
  b = rtIsNaNF(outWidth);
  worldHW[1] = fabsf(spaceToOneSide - (-spaceToOneSide));
  if (!b) {
    p2 = 1;
  }

  if (0 <= p2 - 1) {
    outDimFrac_data[0] = outWidth - 1.0F;
  }

  if (p2 == 0) {
    scale = 0.0F;
  } else {
    scale = outDimFrac_data[0] / worldHW[1];
  }

  p2 = 1;
  if (b) {
    p2 = 2;
  }

  tmp_data[0] = 1;
  if (b) {
    tmp_data[1] = 2;
  }

  for (p3 = 0; p3 < p2; p3++) {
    outDimFrac_data[p3] = scale * worldHW[tmp_data[p3] - 1];
  }

  for (p1 = 0; p1 < p2; p1++) {
    outDimFrac_data[p1] = roundf(outDimFrac_data[p1]);
  }

  p1 = p2 - 1;
  for (p3 = 0; p3 <= p1; p3++) {
    outDimFrac_data[p3]++;
  }

  outSize[0] = outDimFrac_data[0];
  if (b) {
    outSize[1] = outDimFrac_data[1];
  }

  /*  X,Y translation in pixels */
  /*  +1 for placing origin at (1,1) */
  c_cameraObject_Intrinsics_Intri[0] = scale;
  c_cameraObject_Intrinsics_Intri[3] = 0.0F;
  c_cameraObject_Intrinsics_Intri[6] = 0.0F;
  c_cameraObject_Intrinsics_Intri[1] = 0.0F;
  c_cameraObject_Intrinsics_Intri[4] = scale;
  c_cameraObject_Intrinsics_Intri[7] = 0.0F;
  c_cameraObject_Intrinsics_Intri[2] = scale * spaceToOneSide + 1.0F;
  c_cameraObject_Intrinsics_Intri[5] = scale * distAhead + 1.0F;
  c_cameraObject_Intrinsics_Intri[8] = 1.0F;
  for (p3 = 0; p3 < 3; p3++) {
    scale = t0_T[p3 + 3];
    absx21 = t0_T[p3 + 6];
    for (p1 = 0; p1 < 3; p1++) {
      b_t0_T[p3 + 3 * p1] = (t0_T[p3] * (float)b_b[3 * p1] + scale * (float)b_b
        [3 * p1 + 1]) + absx21 * (float)b_b[3 * p1 + 2];
    }

    scale = b_t0_T[p3 + 3];
    absx21 = b_t0_T[p3 + 6];
    for (p1 = 0; p1 < 3; p1++) {
      transformation_matrix[p3 + 3 * p1] = (b_t0_T[p3] *
        c_cameraObject_Intrinsics_Intri[3 * p1] + scale *
        c_cameraObject_Intrinsics_Intri[3 * p1 + 1]) + absx21 *
        c_cameraObject_Intrinsics_Intri[3 * p1 + 2];
    }
  }

  for (p3 = 0; p3 < 9; p3++) {
    c_cameraObject_Intrinsics_Intri[p3] = transformation_matrix[p3];
  }

  p1 = 0;
  p2 = 3;
  p3 = 6;
  scale = fabsf(transformation_matrix[0]);
  absx21 = fabsf(transformation_matrix[1]);
  absx31 = fabsf(transformation_matrix[2]);
  if ((absx21 > scale) && (absx21 > absx31)) {
    p1 = 3;
    p2 = 0;
    c_cameraObject_Intrinsics_Intri[0] = transformation_matrix[1];
    c_cameraObject_Intrinsics_Intri[1] = transformation_matrix[0];
    c_cameraObject_Intrinsics_Intri[3] = transformation_matrix[4];
    c_cameraObject_Intrinsics_Intri[4] = transformation_matrix[3];
    c_cameraObject_Intrinsics_Intri[6] = transformation_matrix[7];
    c_cameraObject_Intrinsics_Intri[7] = transformation_matrix[6];
  } else {
    if (absx31 > scale) {
      p1 = 6;
      p3 = 0;
      c_cameraObject_Intrinsics_Intri[0] = transformation_matrix[2];
      c_cameraObject_Intrinsics_Intri[2] = transformation_matrix[0];
      c_cameraObject_Intrinsics_Intri[3] = transformation_matrix[5];
      c_cameraObject_Intrinsics_Intri[5] = transformation_matrix[3];
      c_cameraObject_Intrinsics_Intri[6] = transformation_matrix[8];
      c_cameraObject_Intrinsics_Intri[8] = transformation_matrix[6];
    }
  }

  c_cameraObject_Intrinsics_Intri[1] /= c_cameraObject_Intrinsics_Intri[0];
  c_cameraObject_Intrinsics_Intri[2] /= c_cameraObject_Intrinsics_Intri[0];
  c_cameraObject_Intrinsics_Intri[4] -= c_cameraObject_Intrinsics_Intri[1] *
    c_cameraObject_Intrinsics_Intri[3];
  c_cameraObject_Intrinsics_Intri[5] -= c_cameraObject_Intrinsics_Intri[2] *
    c_cameraObject_Intrinsics_Intri[3];
  c_cameraObject_Intrinsics_Intri[7] -= c_cameraObject_Intrinsics_Intri[1] *
    c_cameraObject_Intrinsics_Intri[6];
  c_cameraObject_Intrinsics_Intri[8] -= c_cameraObject_Intrinsics_Intri[2] *
    c_cameraObject_Intrinsics_Intri[6];
  if (fabsf(c_cameraObject_Intrinsics_Intri[5]) > fabsf
      (c_cameraObject_Intrinsics_Intri[4])) {
    itmp = p2;
    p2 = p3;
    p3 = itmp;
    scale = c_cameraObject_Intrinsics_Intri[1];
    c_cameraObject_Intrinsics_Intri[1] = c_cameraObject_Intrinsics_Intri[2];
    c_cameraObject_Intrinsics_Intri[2] = scale;
    scale = c_cameraObject_Intrinsics_Intri[4];
    c_cameraObject_Intrinsics_Intri[4] = c_cameraObject_Intrinsics_Intri[5];
    c_cameraObject_Intrinsics_Intri[5] = scale;
    scale = c_cameraObject_Intrinsics_Intri[7];
    c_cameraObject_Intrinsics_Intri[7] = c_cameraObject_Intrinsics_Intri[8];
    c_cameraObject_Intrinsics_Intri[8] = scale;
  }

  c_cameraObject_Intrinsics_Intri[5] /= c_cameraObject_Intrinsics_Intri[4];
  c_cameraObject_Intrinsics_Intri[8] -= c_cameraObject_Intrinsics_Intri[5] *
    c_cameraObject_Intrinsics_Intri[7];
  scale = (c_cameraObject_Intrinsics_Intri[5] * c_cameraObject_Intrinsics_Intri
           [1] - c_cameraObject_Intrinsics_Intri[2]) /
    c_cameraObject_Intrinsics_Intri[8];
  absx21 = -(c_cameraObject_Intrinsics_Intri[1] +
             c_cameraObject_Intrinsics_Intri[7] * scale) /
    c_cameraObject_Intrinsics_Intri[4];
  transformation_matrix[p1] = ((1.0F - c_cameraObject_Intrinsics_Intri[3] *
    absx21) - c_cameraObject_Intrinsics_Intri[6] * scale) /
    c_cameraObject_Intrinsics_Intri[0];
  transformation_matrix[p1 + 1] = absx21;
  transformation_matrix[p1 + 2] = scale;
  scale = -c_cameraObject_Intrinsics_Intri[5] / c_cameraObject_Intrinsics_Intri
    [8];
  absx21 = (1.0F - c_cameraObject_Intrinsics_Intri[7] * scale) /
    c_cameraObject_Intrinsics_Intri[4];
  transformation_matrix[p2] = -(c_cameraObject_Intrinsics_Intri[3] * absx21 +
    c_cameraObject_Intrinsics_Intri[6] * scale) /
    c_cameraObject_Intrinsics_Intri[0];
  transformation_matrix[p2 + 1] = absx21;
  transformation_matrix[p2 + 2] = scale;
  scale = 1.0F / c_cameraObject_Intrinsics_Intri[8];
  absx21 = -c_cameraObject_Intrinsics_Intri[7] * scale /
    c_cameraObject_Intrinsics_Intri[4];
  transformation_matrix[p3] = -(c_cameraObject_Intrinsics_Intri[3] * absx21 +
    c_cameraObject_Intrinsics_Intri[6] * scale) /
    c_cameraObject_Intrinsics_Intri[0];
  transformation_matrix[p3 + 1] = absx21;
  transformation_matrix[p3 + 2] = scale;
}

/*
 * Arguments    : void
 * Return Type  : void
 */
void generate_transformation_matrix_inverse_initialize(void)
{
  rt_InitInfAndNaN();
  isInitialized_generate_transformation_matrix_inverse = true;
}

/*
 * Arguments    : void
 * Return Type  : void
 */
void generate_transformation_matrix_inverse_terminate(void)
{
  /* (no terminate code required) */
  isInitialized_generate_transformation_matrix_inverse = false;
}

/*
 * File trailer for generate_transformation_matrix_inverse.c
 *
 * [EOF]
 */
