/*
 * Academic License - for use in teaching, academic research, and meeting
 * course requirements at degree granting institutions only.  Not for
 * government, commercial, or other organizational use.
 * File: image_to_vehicle.c
 *
 * MATLAB Coder version            : 4.3
 * C/C++ source code generated on  : 30-Apr-2020 14:30:49
 */

/* Include Files */
#include "image_to_vehicle.h"
#include "birds_eye_view_emxutil.h"
#include "rt_nonfinite.h"
#include <arm_neon.h>
#include <math.h>
#include <string.h>

/* Variable Definitions */
static boolean_T isInitialized_image_to_vehicle = false;

/* Function Declarations */
static void inv(const double x[9], double y[9]);
static void polyfit(const emxArray_real32_T *x, const emxArray_real32_T *y,
                    float n, emxArray_real32_T *p);
static void qrpf(emxArray_real32_T *A, int m, int n, emxArray_real32_T *tau,
                 emxArray_int32_T *jpvt);
static float rt_hypotf_snf(float u0, float u1);
static float xnrm2(int n, const emxArray_real32_T *x, int ix0);

/* Function Definitions */

/*
 * Arguments    : const double x[9]
 *                double y[9]
 * Return Type  : void
 */
static void inv(const double x[9], double y[9])
{
  double b_x[9];
  int p1;
  int p2;
  int p3;
  double absx11;
  double absx21;
  double absx31;
  int itmp;
  memcpy(&b_x[0], &x[0], 9U * sizeof(double));
  p1 = 0;
  p2 = 3;
  p3 = 6;
  absx11 = fabs(x[0]);
  absx21 = fabs(x[1]);
  absx31 = fabs(x[2]);
  if ((absx21 > absx11) && (absx21 > absx31)) {
    p1 = 3;
    p2 = 0;
    b_x[0] = x[1];
    b_x[1] = x[0];
    b_x[3] = x[4];
    b_x[4] = x[3];
    b_x[6] = x[7];
    b_x[7] = x[6];
  } else {
    if (absx31 > absx11) {
      p1 = 6;
      p3 = 0;
      b_x[0] = x[2];
      b_x[2] = x[0];
      b_x[3] = x[5];
      b_x[5] = x[3];
      b_x[6] = x[8];
      b_x[8] = x[6];
    }
  }

  b_x[1] /= b_x[0];
  b_x[2] /= b_x[0];
  b_x[4] -= b_x[1] * b_x[3];
  b_x[5] -= b_x[2] * b_x[3];
  b_x[7] -= b_x[1] * b_x[6];
  b_x[8] -= b_x[2] * b_x[6];
  if (fabs(b_x[5]) > fabs(b_x[4])) {
    itmp = p2;
    p2 = p3;
    p3 = itmp;
    absx11 = b_x[1];
    b_x[1] = b_x[2];
    b_x[2] = absx11;
    absx11 = b_x[4];
    b_x[4] = b_x[5];
    b_x[5] = absx11;
    absx11 = b_x[7];
    b_x[7] = b_x[8];
    b_x[8] = absx11;
  }

  b_x[5] /= b_x[4];
  b_x[8] -= b_x[5] * b_x[7];
  absx11 = (b_x[5] * b_x[1] - b_x[2]) / b_x[8];
  absx21 = -(b_x[1] + b_x[7] * absx11) / b_x[4];
  y[p1] = ((1.0 - b_x[3] * absx21) - b_x[6] * absx11) / b_x[0];
  y[p1 + 1] = absx21;
  y[p1 + 2] = absx11;
  absx11 = -b_x[5] / b_x[8];
  absx21 = (1.0 - b_x[7] * absx11) / b_x[4];
  y[p2] = -(b_x[3] * absx21 + b_x[6] * absx11) / b_x[0];
  y[p2 + 1] = absx21;
  y[p2 + 2] = absx11;
  absx11 = 1.0 / b_x[8];
  absx21 = -b_x[7] * absx11 / b_x[4];
  y[p3] = -(b_x[3] * absx21 + b_x[6] * absx11) / b_x[0];
  y[p3 + 1] = absx21;
  y[p3 + 2] = absx11;
}

/*
 * Arguments    : const emxArray_real32_T *x
 *                const emxArray_real32_T *y
 *                float n
 *                emxArray_real32_T *p
 * Return Type  : void
 */
static void polyfit(const emxArray_real32_T *x, const emxArray_real32_T *y,
                    float n, emxArray_real32_T *p)
{
  emxArray_real32_T *V;
  int i;
  int minmana;
  emxArray_real32_T *tau;
  int k;
  int u1;
  int b_n;
  int j;
  float wj;
  emxArray_int32_T *jpvt;
  bool guard1 = false;
  emxArray_real32_T *B;
  emxArray_real32_T *p1;
  int m;
  int mn;
  float32x4_t r;
  float32x4_t r1;
  emxInit_real32_T(&V, 2);
  i = V->size[0] * V->size[1];
  V->size[0] = x->size[0];
  minmana = (int)(n + 1.0F);
  V->size[1] = minmana;
  emxEnsureCapacity_real32_T(V, i);
  if ((x->size[0] != 0) && (minmana != 0)) {
    i = x->size[0];
    for (k = 0; k < i; k++) {
      V->data[k + V->size[0] * (minmana - 1)] = 1.0F;
    }

    if (!(n < 1.0F)) {
      i = x->size[0];
      for (k = 0; k < i; k++) {
        V->data[k + V->size[0] * ((int)n - 1)] = x->data[k];
      }

      i = (int)(((-1.0F - (n - 1.0F)) + 1.0F) / -1.0F);
      for (j = 0; j < i; j++) {
        wj = (n - 1.0F) + -(float)j;
        minmana = x->size[0];
        for (k = 0; k < minmana; k++) {
          V->data[k + V->size[0] * ((int)wj - 1)] = x->data[k] * V->data[k +
            V->size[0] * ((int)(wj + 1.0F) - 1)];
        }
      }
    }
  }

  emxInit_real32_T(&tau, 1);
  k = V->size[0];
  u1 = V->size[1];
  if (k < u1) {
    u1 = k;
  }

  b_n = V->size[1] - 1;
  k = V->size[0];
  minmana = V->size[1];
  if (k < minmana) {
    minmana = k;
  }

  i = tau->size[0];
  tau->size[0] = minmana;
  emxEnsureCapacity_real32_T(tau, i);
  for (i = 0; i < minmana; i++) {
    tau->data[i] = 0.0F;
  }

  emxInit_int32_T(&jpvt, 2);
  guard1 = false;
  if ((V->size[0] == 0) || (V->size[1] == 0)) {
    guard1 = true;
  } else {
    k = V->size[0];
    minmana = V->size[1];
    if (k < minmana) {
      minmana = k;
    }

    if (minmana < 1) {
      guard1 = true;
    } else {
      i = jpvt->size[0] * jpvt->size[1];
      jpvt->size[0] = 1;
      jpvt->size[1] = V->size[1];
      emxEnsureCapacity_int32_T(jpvt, i);
      minmana = V->size[1];
      for (i = 0; i < minmana; i++) {
        jpvt->data[i] = 0;
      }

      for (k = 0; k <= b_n; k++) {
        jpvt->data[k] = k + 1;
      }

      qrpf(V, V->size[0], V->size[1], tau, jpvt);
    }
  }

  if (guard1) {
    i = jpvt->size[0] * jpvt->size[1];
    jpvt->size[0] = 1;
    jpvt->size[1] = V->size[1];
    emxEnsureCapacity_int32_T(jpvt, i);
    minmana = V->size[1];
    for (i = 0; i < minmana; i++) {
      jpvt->data[i] = 0;
    }

    for (j = 0; j <= b_n; j++) {
      jpvt->data[j] = j + 1;
    }
  }

  emxInit_real32_T(&B, 1);
  i = B->size[0];
  B->size[0] = y->size[0];
  emxEnsureCapacity_real32_T(B, i);
  minmana = y->size[0];
  for (i = 0; i < minmana; i++) {
    B->data[i] = y->data[i];
  }

  emxInit_real32_T(&p1, 1);
  i = p1->size[0];
  p1->size[0] = V->size[1];
  emxEnsureCapacity_real32_T(p1, i);
  minmana = V->size[1];
  for (i = 0; i < minmana; i++) {
    p1->data[i] = 0.0F;
  }

  m = V->size[0];
  k = V->size[0];
  mn = V->size[1];
  if (k < mn) {
    mn = k;
  }

  for (j = 0; j < mn; j++) {
    if (tau->data[j] != 0.0F) {
      wj = B->data[j];
      i = j + 2;
      for (minmana = i; minmana <= m; minmana++) {
        wj += V->data[(minmana + V->size[0] * j) - 1] * B->data[minmana - 1];
      }

      wj *= tau->data[j];
      if (wj != 0.0F) {
        B->data[j] -= wj;
        i = j + 2;
        k = ((((m - j) - 1) & -4) + j) + 2;
        b_n = k - 4;
        for (minmana = i; minmana <= b_n; minmana += 4) {
          r = vld1q_f32(&B->data[minmana - 1]);
          r1 = vld1q_f32(&V->data[(minmana + V->size[0] * j) - 1]);
          vst1q_f32(&B->data[minmana - 1], vsubq_f32(r, vmulq_f32(r1,
                      vdupq_n_f32(wj))));
        }

        for (minmana = k; minmana <= m; minmana++) {
          B->data[minmana - 1] -= V->data[(minmana + V->size[0] * j) - 1] * wj;
        }
      }
    }
  }

  emxFree_real32_T(&tau);
  for (minmana = 0; minmana < u1; minmana++) {
    p1->data[jpvt->data[minmana] - 1] = B->data[minmana];
  }

  emxFree_real32_T(&B);
  for (j = u1; j >= 1; j--) {
    i = jpvt->data[j - 1];
    p1->data[i - 1] /= V->data[(j + V->size[0] * (j - 1)) - 1];
    for (minmana = 0; minmana <= j - 2; minmana++) {
      p1->data[jpvt->data[minmana] - 1] -= p1->data[jpvt->data[j - 1] - 1] *
        V->data[minmana + V->size[0] * (j - 1)];
    }
  }

  emxFree_int32_T(&jpvt);
  emxFree_real32_T(&V);
  i = p->size[0] * p->size[1];
  p->size[0] = 1;
  p->size[1] = p1->size[0];
  emxEnsureCapacity_real32_T(p, i);
  minmana = p1->size[0];
  for (i = 0; i < minmana; i++) {
    p->data[i] = p1->data[i];
  }

  emxFree_real32_T(&p1);
}

/*
 * Arguments    : emxArray_real32_T *A
 *                int m
 *                int n
 *                emxArray_real32_T *tau
 *                emxArray_int32_T *jpvt
 * Return Type  : void
 */
static void qrpf(emxArray_real32_T *A, int m, int n, emxArray_real32_T *tau,
                 emxArray_int32_T *jpvt)
{
  emxArray_real32_T *work;
  int ma;
  int minmn;
  int i;
  int itemp;
  emxArray_real32_T *vn1;
  emxArray_real32_T *vn2;
  int iy;
  int b_i;
  float smax;
  int ip1;
  int ii;
  int nmi;
  int mmi;
  int ix;
  int pvt;
  int lastc;
  float temp2;
  float s;
  int jA;
  int lastv;
  bool exitg2;
  int vectorUB;
  float32x4_t r;
  int exitg1;
  emxInit_real32_T(&work, 1);
  ma = A->size[0];
  if (m < n) {
    minmn = m;
  } else {
    minmn = n;
  }

  i = work->size[0];
  work->size[0] = A->size[1];
  emxEnsureCapacity_real32_T(work, i);
  itemp = A->size[1];
  for (i = 0; i < itemp; i++) {
    work->data[i] = 0.0F;
  }

  emxInit_real32_T(&vn1, 1);
  i = vn1->size[0];
  vn1->size[0] = A->size[1];
  emxEnsureCapacity_real32_T(vn1, i);
  itemp = A->size[1];
  for (i = 0; i < itemp; i++) {
    vn1->data[i] = 0.0F;
  }

  emxInit_real32_T(&vn2, 1);
  i = vn2->size[0];
  vn2->size[0] = A->size[1];
  emxEnsureCapacity_real32_T(vn2, i);
  itemp = A->size[1];
  for (i = 0; i < itemp; i++) {
    vn2->data[i] = 0.0F;
  }

  for (iy = 0; iy < n; iy++) {
    smax = xnrm2(m, A, iy * ma + 1);
    vn1->data[iy] = smax;
    vn2->data[iy] = smax;
  }

  for (b_i = 0; b_i < minmn; b_i++) {
    ip1 = b_i + 2;
    iy = b_i * ma;
    ii = iy + b_i;
    nmi = n - b_i;
    mmi = m - b_i;
    if (nmi < 1) {
      itemp = -1;
    } else {
      itemp = 0;
      if (nmi > 1) {
        ix = b_i;
        smax = fabsf(vn1->data[b_i]);
        for (lastc = 2; lastc <= nmi; lastc++) {
          ix++;
          s = fabsf(vn1->data[ix]);
          if (s > smax) {
            itemp = lastc - 1;
            smax = s;
          }
        }
      }
    }

    pvt = b_i + itemp;
    if (pvt + 1 != b_i + 1) {
      ix = pvt * ma;
      for (lastc = 0; lastc < m; lastc++) {
        smax = A->data[ix];
        A->data[ix] = A->data[iy];
        A->data[iy] = smax;
        ix++;
        iy++;
      }

      itemp = jpvt->data[pvt];
      jpvt->data[pvt] = jpvt->data[b_i];
      jpvt->data[b_i] = itemp;
      vn1->data[pvt] = vn1->data[b_i];
      vn2->data[pvt] = vn2->data[b_i];
    }

    if (b_i + 1 < m) {
      temp2 = A->data[ii];
      iy = ii + 2;
      tau->data[b_i] = 0.0F;
      if (mmi > 0) {
        smax = xnrm2(mmi - 1, A, ii + 2);
        if (smax != 0.0F) {
          s = rt_hypotf_snf(A->data[ii], smax);
          if (A->data[ii] >= 0.0F) {
            s = -s;
          }

          if (fabsf(s) < 9.86076132E-32F) {
            itemp = -1;
            i = ii + mmi;
            pvt = ((((i - ii) - 1) & -4) + ii) + 2;
            vectorUB = pvt - 4;
            do {
              itemp++;
              for (lastc = iy; lastc <= vectorUB; lastc += 4) {
                r = vld1q_f32(&A->data[lastc - 1]);
                vst1q_f32(&A->data[lastc - 1], vmulq_f32(vdupq_n_f32
                           (1.01412048E+31F), r));
              }

              for (lastc = pvt; lastc <= i; lastc++) {
                A->data[lastc - 1] *= 1.01412048E+31F;
              }

              s *= 1.01412048E+31F;
              temp2 *= 1.01412048E+31F;
            } while (!(fabsf(s) >= 9.86076132E-32F));

            s = rt_hypotf_snf(temp2, xnrm2(mmi - 1, A, ii + 2));
            if (temp2 >= 0.0F) {
              s = -s;
            }

            tau->data[b_i] = (s - temp2) / s;
            smax = 1.0F / (temp2 - s);
            vectorUB = pvt - 4;
            for (lastc = iy; lastc <= vectorUB; lastc += 4) {
              r = vld1q_f32(&A->data[lastc - 1]);
              vst1q_f32(&A->data[lastc - 1], vmulq_f32(vdupq_n_f32(smax), r));
            }

            for (lastc = pvt; lastc <= i; lastc++) {
              A->data[lastc - 1] *= smax;
            }

            for (lastc = 0; lastc <= itemp; lastc++) {
              s *= 9.86076132E-32F;
            }

            temp2 = s;
          } else {
            tau->data[b_i] = (s - A->data[ii]) / s;
            smax = 1.0F / (A->data[ii] - s);
            i = ii + mmi;
            itemp = ((((i - ii) - 1) & -4) + ii) + 2;
            vectorUB = itemp - 4;
            for (lastc = iy; lastc <= vectorUB; lastc += 4) {
              r = vld1q_f32(&A->data[lastc - 1]);
              vst1q_f32(&A->data[lastc - 1], vmulq_f32(vdupq_n_f32(smax), r));
            }

            for (lastc = itemp; lastc <= i; lastc++) {
              A->data[lastc - 1] *= smax;
            }

            temp2 = s;
          }
        }
      }

      A->data[ii] = temp2;
    } else {
      tau->data[b_i] = 0.0F;
    }

    if (b_i + 1 < n) {
      temp2 = A->data[ii];
      A->data[ii] = 1.0F;
      jA = (ii + ma) + 1;
      if (tau->data[b_i] != 0.0F) {
        lastv = mmi - 1;
        itemp = (ii + mmi) - 1;
        while ((lastv + 1 > 0) && (A->data[itemp] == 0.0F)) {
          lastv--;
          itemp--;
        }

        lastc = nmi - 2;
        exitg2 = false;
        while ((!exitg2) && (lastc + 1 > 0)) {
          itemp = jA + lastc * ma;
          vectorUB = itemp;
          do {
            exitg1 = 0;
            if (vectorUB <= itemp + lastv) {
              if (A->data[vectorUB - 1] != 0.0F) {
                exitg1 = 1;
              } else {
                vectorUB++;
              }
            } else {
              lastc--;
              exitg1 = 2;
            }
          } while (exitg1 == 0);

          if (exitg1 == 1) {
            exitg2 = true;
          }
        }
      } else {
        lastv = -1;
        lastc = -1;
      }

      if (lastv + 1 > 0) {
        if (lastc + 1 != 0) {
          for (iy = 0; iy <= lastc; iy++) {
            work->data[iy] = 0.0F;
          }

          iy = 0;
          i = jA + ma * lastc;
          for (itemp = jA; ma < 0 ? itemp >= i : itemp <= i; itemp += ma) {
            ix = ii;
            smax = 0.0F;
            pvt = itemp + lastv;
            for (vectorUB = itemp; vectorUB <= pvt; vectorUB++) {
              smax += A->data[vectorUB - 1] * A->data[ix];
              ix++;
            }

            work->data[iy] += smax;
            iy++;
          }
        }

        if (!(-tau->data[b_i] == 0.0F)) {
          itemp = 0;
          for (iy = 0; iy <= lastc; iy++) {
            if (work->data[itemp] != 0.0F) {
              smax = work->data[itemp] * -tau->data[b_i];
              ix = ii;
              i = lastv + jA;
              for (pvt = jA; pvt <= i; pvt++) {
                A->data[pvt - 1] += A->data[ix] * smax;
                ix++;
              }
            }

            itemp++;
            jA += ma;
          }
        }
      }

      A->data[ii] = temp2;
    }

    for (iy = ip1; iy <= n; iy++) {
      itemp = b_i + (iy - 1) * ma;
      smax = vn1->data[iy - 1];
      if (smax != 0.0F) {
        s = fabsf(A->data[itemp]) / smax;
        s = 1.0F - s * s;
        if (s < 0.0F) {
          s = 0.0F;
        }

        temp2 = smax / vn2->data[iy - 1];
        temp2 = s * (temp2 * temp2);
        if (temp2 <= 0.000345266977F) {
          if (b_i + 1 < m) {
            smax = xnrm2(mmi - 1, A, itemp + 2);
            vn1->data[iy - 1] = smax;
            vn2->data[iy - 1] = smax;
          } else {
            vn1->data[iy - 1] = 0.0F;
            vn2->data[iy - 1] = 0.0F;
          }
        } else {
          vn1->data[iy - 1] = smax * sqrtf(s);
        }
      }
    }
  }

  emxFree_real32_T(&vn2);
  emxFree_real32_T(&vn1);
  emxFree_real32_T(&work);
}

/*
 * Arguments    : float u0
 *                float u1
 * Return Type  : float
 */
static float rt_hypotf_snf(float u0, float u1)
{
  float y;
  float a;
  a = fabsf(u0);
  y = fabsf(u1);
  if (a < y) {
    a /= y;
    y *= sqrtf(a * a + 1.0F);
  } else if (a > y) {
    y /= a;
    y = a * sqrtf(y * y + 1.0F);
  } else {
    if (!rtIsNaNF(y)) {
      y = a * 1.41421354F;
    }
  }

  return y;
}

/*
 * Arguments    : int n
 *                const emxArray_real32_T *x
 *                int ix0
 * Return Type  : float
 */
static float xnrm2(int n, const emxArray_real32_T *x, int ix0)
{
  float y;
  float scale;
  int kend;
  int k;
  float absxk;
  float t;
  y = 0.0F;
  if (n >= 1) {
    if (n == 1) {
      y = fabsf(x->data[ix0 - 1]);
    } else {
      scale = 1.29246971E-26F;
      kend = (ix0 + n) - 1;
      for (k = ix0; k <= kend; k++) {
        absxk = fabsf(x->data[k - 1]);
        if (absxk > scale) {
          t = scale / absxk;
          y = y * t * t + 1.0F;
          scale = absxk;
        } else {
          t = absxk / scale;
          y += t * t;
        }
      }

      y = scale * sqrtf(y);
    }
  }

  return y;
}

/*
 * Arguments    : unsigned char r_filtered[111900]
 *                const float transform[9]
 *                const emxArray_real32_T *imagePointsCenter
 *                float n
 *                float n_points
 *                float distAhead
 *                emxArray_real32_T *p
 * Return Type  : void
 */
void image_to_vehicle(unsigned char r_filtered[111900], const float transform[9],
                      const emxArray_real32_T *imagePointsCenter, float n, float
                      n_points, float distAhead, emxArray_real32_T *p)
{
  int m;
  bool empty_non_axis_sizes;
  signed char input_sizes_idx_1;
  signed char sizes_idx_1;
  emxArray_real32_T *U;
  int i;
  int loop_ub;
  int coffset;
  emxArray_real32_T *X;
  int inner;
  emxArray_real32_T *vehiclePointsCenter;
  int boffset;
  int b_i;
  int k;
  emxArray_real32_T *b_vehiclePointsCenter;
  int aoffset;
  float temp;
  emxArray_real32_T *c_vehiclePointsCenter;
  emxArray_real32_T *t1;
  emxArray_real32_T *y;
  float32x4_t r;
  float32x4_t r1;
  double b_transform[9];
  double dv[9];
  float Tinv[9];
  bool exitg1;
  float f;
  if (isInitialized_image_to_vehicle == false) {
    image_to_vehicle_initialize();
  }

  if (imagePointsCenter->size[0] != 0) {
    m = imagePointsCenter->size[0];
  } else {
    m = 0;
  }

  empty_non_axis_sizes = (m == 0);
  if (empty_non_axis_sizes || (imagePointsCenter->size[0] != 0)) {
    input_sizes_idx_1 = 2;
  } else {
    input_sizes_idx_1 = 0;
  }

  if (empty_non_axis_sizes || (imagePointsCenter->size[0] != 0)) {
    sizes_idx_1 = 1;
  } else {
    sizes_idx_1 = 0;
  }

  emxInit_real32_T(&U, 2);
  i = U->size[0] * U->size[1];
  U->size[0] = m;
  U->size[1] = input_sizes_idx_1 + sizes_idx_1;
  emxEnsureCapacity_real32_T(U, i);
  loop_ub = input_sizes_idx_1;
  for (i = 0; i < loop_ub; i++) {
    for (coffset = 0; coffset < m; coffset++) {
      U->data[coffset + U->size[0] * i] = imagePointsCenter->data[coffset +
        imagePointsCenter->size[0] * i];
    }
  }

  loop_ub = sizes_idx_1;
  for (i = 0; i < loop_ub; i++) {
    for (coffset = 0; coffset < m; coffset++) {
      U->data[coffset + U->size[0] * input_sizes_idx_1] = 1.0F;
    }
  }

  emxInit_real32_T(&X, 2);
  if (U->size[1] == 1) {
    i = X->size[0] * X->size[1];
    X->size[0] = U->size[0];
    X->size[1] = 3;
    emxEnsureCapacity_real32_T(X, i);
    loop_ub = U->size[0];
    for (i = 0; i < loop_ub; i++) {
      m = U->size[1];
      for (coffset = 0; coffset < 3; coffset++) {
        X->data[i + X->size[0] * coffset] = 0.0F;
        for (inner = 0; inner < m; inner++) {
          X->data[i + X->size[0] * coffset] += U->data[i + U->size[0] * inner] *
            transform[inner + 3 * coffset];
        }
      }
    }
  } else {
    m = U->size[0];
    inner = U->size[1];
    i = X->size[0] * X->size[1];
    X->size[0] = U->size[0];
    X->size[1] = 3;
    emxEnsureCapacity_real32_T(X, i);
    for (loop_ub = 0; loop_ub < 3; loop_ub++) {
      coffset = loop_ub * m;
      boffset = loop_ub * inner;
      for (b_i = 0; b_i < m; b_i++) {
        X->data[coffset + b_i] = 0.0F;
      }

      for (k = 0; k < inner; k++) {
        aoffset = k * m;
        temp = transform[boffset + k];
        for (b_i = 0; b_i < m; b_i++) {
          i = coffset + b_i;
          X->data[i] += temp * U->data[aoffset + b_i];
        }
      }
    }
  }

  emxInit_real32_T(&vehiclePointsCenter, 2);
  if (X->size[0] == 0) {
    vehiclePointsCenter->size[0] = 0;
    vehiclePointsCenter->size[1] = 2;
  } else {
    i = vehiclePointsCenter->size[0] * vehiclePointsCenter->size[1];
    vehiclePointsCenter->size[0] = X->size[0];
    vehiclePointsCenter->size[1] = 2;
    emxEnsureCapacity_real32_T(vehiclePointsCenter, i);
    i = X->size[0];
    for (k = 0; k < i; k++) {
      vehiclePointsCenter->data[k] = X->data[k + X->size[0] * 2];
      vehiclePointsCenter->data[i + k] = X->data[k + X->size[0] * 2];
    }

    loop_ub = X->size[0] - 1;
    i = vehiclePointsCenter->size[0] * vehiclePointsCenter->size[1];
    vehiclePointsCenter->size[0] = X->size[0];
    vehiclePointsCenter->size[1] = 2;
    emxEnsureCapacity_real32_T(vehiclePointsCenter, i);
    for (i = 0; i <= loop_ub; i++) {
      vehiclePointsCenter->data[i] = X->data[i] / vehiclePointsCenter->data[i];
    }

    for (i = 0; i <= loop_ub; i++) {
      vehiclePointsCenter->data[i + vehiclePointsCenter->size[0]] = X->data[i +
        X->size[0]] / vehiclePointsCenter->data[i + vehiclePointsCenter->size[0]];
    }

    loop_ub = vehiclePointsCenter->size[0];
    for (i = 0; i < loop_ub; i++) {
      X->data[i] = vehiclePointsCenter->data[i];
    }

    for (i = 0; i < loop_ub; i++) {
      X->data[i + X->size[0]] = vehiclePointsCenter->data[i +
        vehiclePointsCenter->size[0]];
    }

    loop_ub = X->size[0];
    i = vehiclePointsCenter->size[0] * vehiclePointsCenter->size[1];
    vehiclePointsCenter->size[0] = X->size[0];
    vehiclePointsCenter->size[1] = 2;
    emxEnsureCapacity_real32_T(vehiclePointsCenter, i);
    for (i = 0; i < loop_ub; i++) {
      vehiclePointsCenter->data[i] = X->data[i];
    }

    for (i = 0; i < loop_ub; i++) {
      vehiclePointsCenter->data[i + vehiclePointsCenter->size[0]] = X->data[i +
        X->size[0]];
    }
  }

  emxInit_real32_T(&b_vehiclePointsCenter, 1);
  loop_ub = vehiclePointsCenter->size[0];
  i = b_vehiclePointsCenter->size[0];
  b_vehiclePointsCenter->size[0] = vehiclePointsCenter->size[0];
  emxEnsureCapacity_real32_T(b_vehiclePointsCenter, i);
  for (i = 0; i < loop_ub; i++) {
    b_vehiclePointsCenter->data[i] = vehiclePointsCenter->data[i];
  }

  emxInit_real32_T(&c_vehiclePointsCenter, 1);
  loop_ub = vehiclePointsCenter->size[0];
  i = c_vehiclePointsCenter->size[0];
  c_vehiclePointsCenter->size[0] = vehiclePointsCenter->size[0];
  emxEnsureCapacity_real32_T(c_vehiclePointsCenter, i);
  for (i = 0; i < loop_ub; i++) {
    c_vehiclePointsCenter->data[i] = vehiclePointsCenter->data[i +
      vehiclePointsCenter->size[0]];
  }

  polyfit(b_vehiclePointsCenter, c_vehiclePointsCenter, n, p);
  temp = n_points;
  emxFree_real32_T(&c_vehiclePointsCenter);
  emxFree_real32_T(&b_vehiclePointsCenter);
  if (n_points < 0.0F) {
    temp = 0.0F;
  }

  emxInit_real32_T(&t1, 2);
  i = t1->size[0] * t1->size[1];
  t1->size[0] = 1;
  coffset = (int)floorf(temp);
  t1->size[1] = coffset;
  emxEnsureCapacity_real32_T(t1, i);
  if (coffset >= 1) {
    m = coffset - 1;
    t1->data[m] = distAhead;
    if (t1->size[1] >= 2) {
      t1->data[0] = 0.0F;
      if (t1->size[1] >= 3) {
        if ((0.0F == -distAhead) && (coffset > 2)) {
          for (k = 2; k <= m; k++) {
            t1->data[k - 1] = distAhead * ((float)(((k << 1) - coffset) - 1) /
              (float)(coffset - 1));
          }

          if ((coffset & 1) == 1) {
            t1->data[coffset >> 1] = 0.0F;
          }
        } else if ((distAhead < 0.0F) && (fabsf(distAhead) > 1.70141173E+38F)) {
          temp = distAhead / (float)((double)t1->size[1] - 1.0);
          i = t1->size[1];
          for (k = 0; k <= i - 3; k++) {
            t1->data[k + 1] = temp * (float)((double)k + 1.0);
          }
        } else {
          temp = distAhead / (float)((double)t1->size[1] - 1.0);
          i = t1->size[1];
          for (k = 0; k <= i - 3; k++) {
            t1->data[k + 1] = (float)((double)k + 1.0) * temp;
          }
        }
      }
    }
  }

  i = (int)n_points;
  coffset = vehiclePointsCenter->size[0] * vehiclePointsCenter->size[1];
  vehiclePointsCenter->size[0] = i;
  vehiclePointsCenter->size[1] = 2;
  emxEnsureCapacity_real32_T(vehiclePointsCenter, coffset);
  loop_ub = i << 1;
  for (i = 0; i < loop_ub; i++) {
    vehiclePointsCenter->data[i] = 0.0F;
  }

  emxInit_real32_T(&y, 2);
  i = y->size[0] * y->size[1];
  y->size[0] = 1;
  y->size[1] = t1->size[1];
  emxEnsureCapacity_real32_T(y, i);
  if ((t1->size[1] != 0) && (p->size[1] != 0)) {
    i = y->size[0] * y->size[1];
    y->size[0] = 1;
    emxEnsureCapacity_real32_T(y, i);
    loop_ub = t1->size[1];
    for (i = 0; i < loop_ub; i++) {
      y->data[i] = p->data[0];
    }

    i = p->size[1];
    for (k = 0; k <= i - 2; k++) {
      coffset = y->size[0] * y->size[1];
      y->size[0] = 1;
      y->size[1] = t1->size[1];
      emxEnsureCapacity_real32_T(y, coffset);
      temp = p->data[k + 1];
      loop_ub = t1->size[0] * t1->size[1] - 1;
      m = (t1->size[0] * t1->size[1]) & -4;
      inner = m - 4;
      for (coffset = 0; coffset <= inner; coffset += 4) {
        r = vld1q_f32(&t1->data[coffset]);
        r1 = vld1q_f32(&y->data[coffset]);
        vst1q_f32(&y->data[coffset], vaddq_f32(vmulq_f32(r, r1), vdupq_n_f32
                   (temp)));
      }

      for (coffset = m; coffset <= loop_ub; coffset++) {
        y->data[coffset] = t1->data[coffset] * y->data[coffset] + temp;
      }
    }
  }

  loop_ub = y->size[1];
  for (i = 0; i < loop_ub; i++) {
    vehiclePointsCenter->data[i + vehiclePointsCenter->size[0]] = y->data[i];
  }

  emxFree_real32_T(&y);
  loop_ub = vehiclePointsCenter->size[0];
  for (i = 0; i < loop_ub; i++) {
    vehiclePointsCenter->data[i] = t1->data[i];
  }

  emxFree_real32_T(&t1);
  if (vehiclePointsCenter->size[0] != 0) {
    m = vehiclePointsCenter->size[0];
  } else {
    m = 0;
  }

  empty_non_axis_sizes = (m == 0);
  if (empty_non_axis_sizes || (vehiclePointsCenter->size[0] != 0)) {
    input_sizes_idx_1 = 2;
  } else {
    input_sizes_idx_1 = 0;
  }

  if (empty_non_axis_sizes || (vehiclePointsCenter->size[0] != 0)) {
    sizes_idx_1 = 1;
  } else {
    sizes_idx_1 = 0;
  }

  i = U->size[0] * U->size[1];
  U->size[0] = m;
  U->size[1] = input_sizes_idx_1 + sizes_idx_1;
  emxEnsureCapacity_real32_T(U, i);
  loop_ub = input_sizes_idx_1;
  for (i = 0; i < loop_ub; i++) {
    for (coffset = 0; coffset < m; coffset++) {
      U->data[coffset + U->size[0] * i] = vehiclePointsCenter->data[coffset +
        vehiclePointsCenter->size[0] * i];
    }
  }

  loop_ub = sizes_idx_1;
  for (i = 0; i < loop_ub; i++) {
    for (coffset = 0; coffset < m; coffset++) {
      U->data[coffset + U->size[0] * input_sizes_idx_1] = 1.0F;
    }
  }

  for (i = 0; i < 9; i++) {
    b_transform[i] = transform[i];
  }

  inv(b_transform, dv);
  for (i = 0; i < 9; i++) {
    Tinv[i] = (float)dv[i];
  }

  if (U->size[1] == 1) {
    i = X->size[0] * X->size[1];
    X->size[0] = U->size[0];
    X->size[1] = 3;
    emxEnsureCapacity_real32_T(X, i);
    loop_ub = U->size[0];
    for (i = 0; i < loop_ub; i++) {
      m = U->size[1];
      for (coffset = 0; coffset < 3; coffset++) {
        X->data[i + X->size[0] * coffset] = 0.0F;
        for (inner = 0; inner < m; inner++) {
          X->data[i + X->size[0] * coffset] += U->data[i + U->size[0] * inner] *
            Tinv[inner + 3 * coffset];
        }
      }
    }
  } else {
    m = U->size[0];
    inner = U->size[1];
    i = X->size[0] * X->size[1];
    X->size[0] = U->size[0];
    X->size[1] = 3;
    emxEnsureCapacity_real32_T(X, i);
    for (loop_ub = 0; loop_ub < 3; loop_ub++) {
      coffset = loop_ub * m;
      boffset = loop_ub * inner;
      for (b_i = 0; b_i < m; b_i++) {
        X->data[coffset + b_i] = 0.0F;
      }

      for (k = 0; k < inner; k++) {
        aoffset = k * m;
        temp = Tinv[boffset + k];
        for (b_i = 0; b_i < m; b_i++) {
          i = coffset + b_i;
          X->data[i] += temp * U->data[aoffset + b_i];
        }
      }
    }
  }

  emxFree_real32_T(&U);
  if (X->size[0] == 0) {
    vehiclePointsCenter->size[0] = 0;
    vehiclePointsCenter->size[1] = 2;
  } else {
    i = vehiclePointsCenter->size[0] * vehiclePointsCenter->size[1];
    vehiclePointsCenter->size[0] = X->size[0];
    vehiclePointsCenter->size[1] = 2;
    emxEnsureCapacity_real32_T(vehiclePointsCenter, i);
    i = X->size[0];
    for (k = 0; k < i; k++) {
      vehiclePointsCenter->data[k] = X->data[k + X->size[0] * 2];
      vehiclePointsCenter->data[i + k] = X->data[k + X->size[0] * 2];
    }

    loop_ub = X->size[0] - 1;
    i = vehiclePointsCenter->size[0] * vehiclePointsCenter->size[1];
    vehiclePointsCenter->size[0] = X->size[0];
    vehiclePointsCenter->size[1] = 2;
    emxEnsureCapacity_real32_T(vehiclePointsCenter, i);
    for (i = 0; i <= loop_ub; i++) {
      vehiclePointsCenter->data[i] = X->data[i] / vehiclePointsCenter->data[i];
    }

    for (i = 0; i <= loop_ub; i++) {
      vehiclePointsCenter->data[i + vehiclePointsCenter->size[0]] = X->data[i +
        X->size[0]] / vehiclePointsCenter->data[i + vehiclePointsCenter->size[0]];
    }

    loop_ub = vehiclePointsCenter->size[0];
    for (i = 0; i < loop_ub; i++) {
      X->data[i] = vehiclePointsCenter->data[i];
    }

    for (i = 0; i < loop_ub; i++) {
      X->data[i + X->size[0]] = vehiclePointsCenter->data[i +
        vehiclePointsCenter->size[0]];
    }

    loop_ub = X->size[0];
    i = vehiclePointsCenter->size[0] * vehiclePointsCenter->size[1];
    vehiclePointsCenter->size[0] = X->size[0];
    vehiclePointsCenter->size[1] = 2;
    emxEnsureCapacity_real32_T(vehiclePointsCenter, i);
    for (i = 0; i < loop_ub; i++) {
      vehiclePointsCenter->data[i] = X->data[i];
    }

    for (i = 0; i < loop_ub; i++) {
      vehiclePointsCenter->data[i + vehiclePointsCenter->size[0]] = X->data[i +
        X->size[0]];
    }
  }

  emxFree_real32_T(&X);
  i = (int)(((-1.0F - n_points) + 1.0F) / -1.0F);
  b_i = 0;
  exitg1 = false;
  while ((!exitg1) && (b_i <= i - 1)) {
    coffset = (int)(n_points + -(float)b_i) - 1;
    temp = vehiclePointsCenter->data[coffset + vehiclePointsCenter->size[0]];
    if (temp > 746.0F) {
      exitg1 = true;
    } else {
      temp = roundf(temp);
      if (!rtIsNaNF(temp)) {
        f = roundf(vehiclePointsCenter->data[coffset]);
        if ((!rtIsNaNF(f)) && (!(temp <= 0.0F)) && (!(f <= 0.0F)) && (!(f >
              150.0F))) {
          r_filtered[((int)temp + 746 * ((int)f - 1)) - 1] = MAX_uint8_T;
        }
      }

      b_i++;
    }
  }

  emxFree_real32_T(&vehiclePointsCenter);
}

/*
 * Arguments    : void
 * Return Type  : void
 */
void image_to_vehicle_initialize(void)
{
  rt_InitInfAndNaN();
  isInitialized_image_to_vehicle = true;
}

/*
 * Arguments    : void
 * Return Type  : void
 */
void image_to_vehicle_terminate(void)
{
  /* (no terminate code required) */
  isInitialized_image_to_vehicle = false;
}

/*
 * File trailer for image_to_vehicle.c
 *
 * [EOF]
 */
