#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QWidget>
#include <QThread>
#include <QString>
#include <QLabel>
#include <QPixmap>
#include <QApplication>
#include "goldworker.hpp"
#include "inputparameter.h"

class MainWindow : public QWidget
{
    Q_OBJECT
public:
    explicit MainWindow(QSize size, QWidget *parent = nullptr);
    ~MainWindow();
    void initializeThread(InputParameter input);

public slots:
    void update_content(QPixmap image);
    void error();
    void quit();

private:
    QLabel *main_label;
    QSize size;
    GOLDWorker* worker;
    QThread* execution_thread;
};

#endif // MAINWINDOW_H
