function [p, r_filtered] = filter_grey_bev_1080p(GreyBEV, m, threshold, min_val, m_filter, t)

[h, w] = size(GreyBEV);

r = zeros(h,w);
r_filtered = r;

for i = 1:h
    for j = 1:w
        
        if ((j - m) > 0)
            jmm = j - m;
        else
            jmm = 1;
        end
        
        if ((j + m) <= w)
            jmp = j + m;
        else
            jmp = w;
        end
      
        if ((GreyBEV(i,j)-GreyBEV(i,jmp)>threshold))&&...
                ((GreyBEV(i,j)-GreyBEV(i,jmm)>threshold))
            
            r(i,j) = GreyBEV(i,j)-GreyBEV(i,jmp)+GreyBEV(i,j)-GreyBEV(i,jmm);
        end
            
    end
end

r = medfilt2(r);

for i = 1:h
    for j = 1:w   
        if (r(i,j) < min_val)
            r(i,j) = 0;
        end
    end
end

for i = 1:h
    for j = 1:w
        
        if ((i - m_filter) > 0)
            imm = i - m_filter;
        else
            imm = 1;
        end
        
        if ((i + m_filter) <= h)
            imp = i + m_filter;
        else
            imp = h;
        end
      
        if (((r(i,j) ~= 0)) && ((r(imp,j) ~= 0) || (r(imm,j) ~= 0)))
            r_filtered(i,j) = 100;
        else
            r_filtered(i,j) = 0;
        end
  
    end
end

r_filtered = uint8(r_filtered);

values = zeros(w);

for i=1:h
    
    left_index = -1;
    for j=round(w/2):-1:1
        if r_filtered(i, j) ~= 0
            left_index = j;
            break;
        end
    end 
    
    right_index = -1;
    for j=round(w/2):w
        if r_filtered(i, j) ~= 0
            right_index = j;
            break;
        end
    end
    
    if (left_index == -1 || right_index == -1)
        continue;
    end
    
    distance = right_index - left_index;
    values(distance + 1) = values(distance + 1) + 1;  
    
end

max = 0;
final_distance = -1;
for i=1:w
   if values(i) > max
       max = values(i);
       final_distance = i;
   end
end

first = 1;
count = 0;
for i=1:h
    
    left_index = -1;
    for j=round(w/2):-1:1
        if r_filtered(i, j) ~= 0
            left_index = j;
            break;
        end
    end 
    
    right_index = -1;
    for j=round(w/2):w
        if r_filtered(i, j) ~= 0
            right_index = j;
            break;
        end
    end
    
    if (left_index == -1 || right_index == -1)
        continue;
    end
    
    count = count + 1;
    
    distance = right_index - left_index;
    if (distance > final_distance - w/10 && distance < final_distance + w/10)
        
        new_row_left = [left_index, i];
        new_row_right = [right_index, i];
        new_central_row = [left_index + distance / 2, i];
        
        r_filtered(i, left_index) = 255;
        r_filtered(i, right_index) = 255;
%         r_filtered(i, round(left_index + distance / 2)) = 255;
        
        if first == 1
            first = 0;
            imagePointsLeft = new_row_left;
            imagePointsRight = new_row_right;
            imagePointsCenter = new_central_row;
        else
            imagePointsLeft = [imagePointsLeft; new_row_left];
            imagePointsRight = [imagePointsRight; new_row_right];
            imagePointsCenter = [imagePointsCenter; new_central_row];
        end
        
    end
    
end

if count > 3
    [p, r_filtered] = image_to_vehicle(r_filtered, t, imagePointsCenter, 3, 200, 40);
end

end






