function [p, r_filtered] = image_to_vehicle(r_filtered, transform, imagePointsCenter, n, n_points, distAhead)

[h, w] = size(r_filtered);

vehiclePointsCenter = transformPointsForward(projective2d(transform), imagePointsCenter);

p = polyfit(vehiclePointsCenter(:,1), vehiclePointsCenter(:,2), n);

t1 = linspace(0, distAhead, n_points);
mat = zeros(n_points, 2);
mat(:,2) = polyval(p, t1)';
mat(:,1) = t1;

imagePointsFinal = transformPointsInverse(projective2d(transform), mat);

for i=n_points:-1:1   

    if imagePointsFinal(i,2) > h
       break; 
    end
    
    if (isnan(round(imagePointsFinal(i,2))) || isnan(round(imagePointsFinal(i,1))))
        continue;
    end
    
    if (round(imagePointsFinal(i,2)) <= 0 || round(imagePointsFinal(i,2)) > h || round(imagePointsFinal(i,1)) <= 0 || round(imagePointsFinal(i,1)) > w )
        continue;
    end       

    r_filtered(round(imagePointsFinal(i,2)), round(imagePointsFinal(i,1)))= 255;
end

end